// -------------------------------------------------------------------------\\
//          
// File:        pod.h
// Author:      Bettina McCormick
//          
// Project:     Atlantis: COP 2224 VCC; Summer 1999
//          
// Created:     June 30, 1999
// Updated:     July 25, 1999
// Date due:    August 04, 1999
//             
// Description: Specification for Pod class
//      
//              Inherits from Target - Pod "is a" Target
//        
// Notes:       Turn on symbol POD_TEST to test this component
//      
// -------------------------------------------------------------------------//
  
#ifndef POD_H         // standard header wrapper
#define POD_H
        
#include <iostream>
#include <string>
        
#include "constuff.h"
#include "target.h"
  
namespace Atlantis    // project namespace
{
    
  static enum PodTypes   // for better readability
  {
    IDLENESS,     // 0
    DESIRE,       // 1
    ENVY,         // 2
    SELFISHNESS,  // 3
    GREED         // 4
  };
  
  class Pod : public Target // inherits from target
  {
  public:
    static Pod * Create ( int pod_type );
    /**------------------------------------------------------------------------
    // no public constructor: this calls private constructor to create instance
    // of pod and returns Pod *
    //-----------------------------------------------------------------------*/
      
    ~Pod();
    /**------------------------------------------------------------------------
    // destructor
    //-----------------------------------------------------------------------*/
      
    bool Hit( void );
    /**------------------------------------------------------------------------
    // returns true and hits Pod if not already destroyed, false otherwise, 
    //-----------------------------------------------------------------------*/
    
    void Show( void ) const;
    /**------------------------------------------------------------------------
    // calls base class method: shows pods name, armor level, hits & status
    //-----------------------------------------------------------------------*/
    
    void Show ( bool hitflag ) const;
    /**------------------------------------------------------------------------
    // overloaded show method: hitflag is true if pod is hit, false if missed
    //-----------------------------------------------------------------------*/
    
    void Abstract ( void );  
    /**------------------------------------------------------------------------
    // fullfills virtual bass class method
    //-----------------------------------------------------------------------*/
    
  private:
    Pod ( std::string name, int armor, int maxdepth, int val,int t_type );
    /**------------------------------------------------------------------------
    // private constructor calls virtual constructor of base class
    //-----------------------------------------------------------------------*/
      
    int value; // value of pod - used in scoring
  }; // end class Pod
  
} // namespace Atlantis

#endif // POD_H

// eof pod.h
