// ***************************************************************************
//
// File:        ball.h
// Author:      Bettina McCormick
//
// Project:     Midterm: COP 2224 VCC; Summer 1999
// Template:    Created by Professor Richard Mudge
//
// Created:     June 11, 1999
// Updated:     June 15, 1999
// Date due:    June 28, 1999
// 
// Description: Specification for the ball object that is used with the lotto 
//              object in a simulation of a lotto machine.
//
// ***************************************************************************


#ifndef BALL_H    // standard header wrapper
#define BALL_H    

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


   class Ball
   {
   public:
   
      Ball( unsigned char n = 0 );  // Constructor
   
      ~Ball(); // Destructor 
   
      void Show (void); // Shows number value and if picked
   
      void Set_number ( unsigned char n );  // Sets number value
   
      unsigned char Get_number ( void );    // Gets number value
   
      bool  Pick ( void );   // If not picked, set picked, return true
   
      void Reset ( void );   // Resets ball to not picked
   
   private:
   
      static bool initialized;    // T/F for initialization
   
      enum size{ COLOR_SIZE = 21 };
   
      unsigned char number;   // Number value of ball
   
      bool picked;            // True or False
   
      char color[COLOR_SIZE]; // String value describing color
   
   };

#endif

// end ball.h