// ***************************************************************************
//          
// File:        playslip.h
// Author:      Bettina McCormick
//          
// Project:     Midterm: COP 2224 VCC; Summer 1999
//          
// Created:     June 18, 1999
// Updated:     June 23, 1999
// Date due:    June 28, 1999
//             
// Description: Specification for the PlaySlip object that is used with  
//              the ball and Lotto machine objects in a simulation of a 
//              lotto machine.
//             
//              Added to midterm for enhancement of lotto main and to 
//              learn the creation of a class with no template.  
//             
// ***************************************************************************
            
            
#ifndef PLAYSLIP_H   // standard header wrapper
#define PLAYSLIP_H
      
#include "ball.h"
#include "lmach.h"
      
#include <fstream.h> // don't assume these have been included in other header
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>
      
      
   class PlaySlip
   {
   public:
      
      PlaySlip( unsigned char t = 6, unsigned char p = 5 );// Constructor
      
      ~PlaySlip(); // Destructor
      
      void Set_values ( unsigned char t, unsigned char p );// Set private
      
      char * Get_type ( void ); // Returns a string describing type
         
      int Get_panels ( void ); // Returns no of panels to be filled
         
      void Fill_slip ( void ); // Fills slip with lm picks     
      
      void Show ( void ); // Show the Play Slip values
         
      void Show ( ofstream & outfile ); // Show the Play Slip values to file 
         
      void Reset ( void );  // Resets the Play Slip to biggest lotto
      
   private:
      
      enum lm_size   {  CASH3_SIZE     = 10,  // lotto machine
                        PLAY4_SIZE     = 10,
                        FANTASY5_SIZE  = 26,
                        LOTTO_SIZE     = 49 }; // sizes
   
      enum pick_size {  NO_CASH3_PICKS    = 3, // number of
                        NO_PLAY4_PICKS    = 4, // picks per
                        NO_FANTASY5_PICKS = 5, // play slip
                        NO_LOTTO_PICKS    = 6 };
            
      enum max_vals  {  MAX_PANELS   = 5,  // max panels per slip
                        MAX_PICKS    = 6 };// max lottery picks
         
      Ball slip_contents[MAX_PANELS][MAX_PICKS];  //  play slip
         
      unsigned char type;     // Type of Play Slip
         
      unsigned char size;     // Size of pick_generator
         
      unsigned char panels;   // Number of panels to be filled
         
      unsigned char no_picks; // Number of picks
         
   };
      
#endif

// end playslip.h
