/******************************************************************************\
	Bettina McCormick, April 1998, CSIII, Dr. Leeson, Assignment #3

	Tree Investigation Project  - Due Date: Wednesday April 29, 1998

	Main Program:  trees.c  Version 2.1 - last updated  April 27, 1998

	 This program investigates two different tree structures:
	 the Binary Search Tree (BST) and the Two-Three Tree (TTT).

\******************************************************************************/

 #include "bstree.h"
 #include "tttree.h"
 #include "trees.h" 
/******************************************************************************/
/***************************   F U N C T I O N S  *****************************/

/*--------------------------------------------------------------   bstree.c   */
/*-----------------------------B S T _ I N S E R T----------------------------*\

 Purpose: To insert an integer value in the BST

 Pre-Condition : Follow Parameters

 Post-Condition: the data passed is inserted to the BST.

 Return: the root of the BST

\*----------------------------------------------------------------------------*/
   bstnode *bst_insert(bstnode *root, int data)
   
   {
      if (root == NULL)  /* a new integer has arrived */
      {
         if ((root = (bstnode*) malloc(sizeof(bstnode))) == NULL)
         {
            printf("Not enough memory to allocate node\n");
            exit(1);
         } /* end if */
         root -> value = data;
         root -> right = NULL;
         root -> left = NULL;
      } /* end if */
      else if (data < root -> value)
         root -> left = bst_insert(root -> left, data);
      else
         root -> right = bst_insert(root -> right, data);
      return root;
   } /* end bst_insert */

/*-----------------------------B S T _ S E A R C H----------------------------*\

 Purpose: To search the BST for the data, counting the number of times data
			 is compared

 Pre-Condition : Follow Parameters

 Post-Condition: value of compares is passed back

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_search(bstnode *root, int data, int *cmprs)
   {
   
      if (data == root -> value)
         *cmprs = *cmprs + 1;
      else if (data < root -> value)
      {
         bst_search(root -> left, data, cmprs);
         *cmprs = *cmprs + 1;
      }
      else
      {
         bst_search(root -> right, data, cmprs);
         *cmprs = *cmprs + 1;
      }
      return;
   } /* end bst_search */

/*-----------------------------B S T _ I N O R D E R--------------------------*\

 Purpose: does inorder traversal of BST and prints results to test file

 Pre-Condition : Follow Parameters: file is open for writing

 Post-Condition: data is written to file and file is still open

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_inorder(bstnode *root, FILE **fp)
   {
      if (root != NULL)
      {
         bst_inorder(root -> left, fp);
         fprintf(*fp, "%d\n", root -> value);
         bst_inorder(root -> right, fp);
      } /* end if */
   } /* end bst_inorder */

/*------------------------------B S T _ F R E E ------------------------------*\

 Purpose: frees all the pointers in the BSTree for good memory management

 Pre-Condition : Follow Parameters

 Post-Condition: memory for bstree is freed

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_free(bstnode *root)
   {
      if (root != NULL)
      {
         bst_free(root -> left);
         bst_free(root -> right);
         root = NULL;
         free(root);
      } /* end if */
   } /* end bst_free */
/*-----------------------------------------------------------  end bstree.c   */
