/******************************************************************************\
	 Bettina McCormick, April 1998, CSIII, Dr. Leeson, Assignment #3

	 Tree Investigation Project  - Due Date: Wednesday April 29, 1998

	 Main Program:  trees.c  Version 2.1 - last updated  April 27, 1998

	 This program investigates two different tree structures:
	 the Binary Search Tree (BST) and the Two-Three Tree (TTT).

\******************************************************************************/

/*--------------------------    bst_ttt.h     --------------------------------*/


#ifndef _BSTREE_H_
#define _BSTREE_H_    1

#include "trees.h"
/***********************    S T R U C T U R E S    **************************/

/*----------------------------    bstree     -------------------------------*/

   struct bst_type{                   /* node for the BST */
      int value;
      struct bst_type    *right;
      struct bst_type    *left;
   };

   typedef struct bst_type bstnode;


/***********************     P R O T O T Y P E S     **************************/
/*--------------------------    bstree.h     -------------------------------*/
/*-----------------------------B S T _ I N S E R T----------------------------*\

 Purpose: To insert an integer value in the BST

 Pre-Condition : Follow Parameters

 Post-Condition: the data passed is inserted to the BST.

 Return: the root of the BST

\*----------------------------------------------------------------------------*/
   bstnode *bst_insert(bstnode *root, int data);

/*-----------------------------B S T _ S E A R C H----------------------------*\

 Purpose: To search the BST for the data, counting the number of times data
			 is compared

 Pre-Condition : Follow Parameters

 Post-Condition: value of compares is passed back

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_search(bstnode *root, int data, int *cmprs);

/*-----------------------------B S T _ I N O R D E R--------------------------*\

 Purpose: does inorder traversal of BST and prints results to test file

 Pre-Condition : Follow Parameters: file is open for writing

 Post-Condition: data is written to file and file is still open

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_inorder(bstnode *root, FILE **fp);

/*------------------------------B S T _ F R E E ------------------------------*\

 Purpose: frees all the pointers in the BSTree for good memory management

 Pre-Condition : Follow Parameters

 Post-Condition: memory for bstree is freed

 Return: void

\*----------------------------------------------------------------------------*/
   void bst_free(bstnode *root);

#endif
