/******************************************************************************\
		 Bettina McCormick, April 1998, CSIII, Dr. Leeson, Assignment #3

		 Tree Investigation Project  - Due Date: Wednesday April 29, 1998

		 Main Program:  trees.c  Version 2.1 - last updated  April 27, 1998

	 This program investigates two different tree structures:
	 the Binary Search Tree (BST) and the Two-Three Tree (TTT).

\******************************************************************************/

/*--------------------------    tttree.h     --------------------------------*/


#ifndef _TTTREE_H_
#define _TTTREE_H_    1

#include "trees.h"


/*----------------------------    tttree     -------------------------------*/

#define SINGLE             1
#define MARRIED            2

/***********************    S T R U C T U R E S    **************************/

/*----------------------------    tttree     -------------------------------*/


   struct ttt_type{                   /* node for the BST */
      int rightval;
      int leftval;
      int parent;
      int return_value;
      struct ttt_type    *right;
      struct ttt_type    *center;
      struct ttt_type    *left;
      struct ttt_type    *extra;
      struct ttt_type    *new_sibling;
   };

   typedef struct ttt_type tttnode;

/***********************     P R O T O T Y P E S     **************************/

/*----------------------T T T _N E W N O D E _ I N S E R T--------------------*\

 Purpose: called when a new node is needed for inserting

 Pre-Condition : Follow Parameters;

 Post-Condition: the data has been inserted and the node initialized

 Return: a pionter to the node created
\*----------------------------------------------------------------------------*/
   tttnode *ttt_newnode_insert(int data);

/*-----------------------------T T T _ I S L E A F----------------------------*\
 Purpose: checks if the node passed is a leaf

 Pre-Condition : Follow Parameters;

 Post-Condition: node has been checked for leaf property

 Return: TRUE if it is a leaf; FALSE otherwise
\*----------------------------------------------------------------------------*/
   int ttt_isleaf(tttnode *node);

/*---------------------T T T _ S I M P L E _ I N S E R T----------------------*\

 Purpose: inserts a data value in the rightval field of the node passed

 Pre-Condition : Follow Parameters;

 Post-Condition: the data has been inserted only - might not be in the
					  right relationship

 Return: EXIT_SUCCESS

\*----------------------------------------------------------------------------*/
   int ttt_simple_insert(tttnode *node, int data);

/*---------------------T T T _ A D J U S T _ V A L U E S----------------------*\

 Purpose: Swaps the values in a node to there proper relatinship.

 Pre-Condition : Follow Parameters;

 Post-Condition: the data has been swaped if necessary

 Return: EXIT_SUCCESS

\*----------------------------------------------------------------------------*/
   int ttt_adjust_values(tttnode *node);

/*-----------------------------T T T _ I N S E R T----------------------------*\

 Purpose: This routine calls the TTT routines: it inserts a new value into the
			 2-3 tree - keeping it balanced.

 Pre-Condition : Follow Parameters;

 Post-Condition: the data has been inserted in the TTTree.

 Return: a pointer to the root of the tree.

 Comments: Whew - this baby was tough! -  I did a combination of recursion
 and parent pointing; I can't wait to learn C++!  I think it will make things
 like this alot easier!!


\*----------------------------------------------------------------------------*/
   tttnode *ttt_insert(tttnode *root, int data);

#endif
