/* *********************************************************************** *\
      Bettina McCormick, March 1998, CSIII, Dr. Leeson, Assignment #2

      Hash Table Comparison Project  - Due Date: March 11, 1998

      Closed Hash Header: chash.h Version 5.1- last updated March 5, 1998

      This header file is used by hashes.c - it contains the structures
      and prototypes for the closed hashing.
\* *********************************************************************** */

#ifndef _CHASH_H_
#define _CHASH_H_    1

#include "hashes.h"


#define VIRGIN            -1
#define EXTRA           1000

/******************************    stuctures    ****************************/

   struct ctabtype{
      int *hashtab,          /* hash table */
      binsize,
      oflowsize,
      oflowstart,
      lastoflow,
      tabsize;          /* tablesize */
   };

   typedef struct ctabtype closed_hashtable;


/*********************      function prototypes     ************************/

   closed_hashtable Init_ClosedHashTable(int ts, int bs);
/*  Takes the table size and bin size, mallocs space and initializes the
    tabsize to table size, the binsize to the bin size. Calculates overflow
    size and initializes all slots to VIRGIN. Returns the table.  */

   int Hash_ClosedHashTable(closed_hashtable *H, int r);
/*  Takes pointer to table and the value to be hashed;
    returns the hash index.  */

   int Find_ClosedHashTable(closed_hashtable *H, int r);
/*  Takes table and the value to be found; returns TRUE if found.  */
/* This function is not really necessary to this program b/c data file
   will contain no duplicates - however, I wanted to wirte it for the
   logic, and in keeping with a more normal hash process. */

   int Insert_ClosedHashTable(closed_hashtable *H, int r);
/*  Takes the hash table and the value to be inserted;
    calls Hash_OpenHashTable and Find_OpenHashTable;
    post condition - pointer to new node has been inserted in hash table.  */

   int OutputStats_Closed(closed_hashtable *H);
/* Takes the hash table and output the statistics:  # of filled slots
   of the table, percentage filed, longest list length, and average
   list length. */

   int ClosedHash(char *input, int ts);
/* Takes pointer to the file pointer and table size; reads in a
   file of non- duplicating integers, creates hash table and prints
   statistics. */

#endif


/*******************************   end chash.h   ***************************/


