/* ************************************************************************** *\
       Bettina McCormick, March 1998, CSIII, Dr. Leeson, Assignment #2

          Hash Table Comparison Project  - Due Date: March 11, 1998

      Open Hash Header: ohash.h Version 5.1- last updated March 5, 1998

      This header file is used by hashes.c - it contains the structures
      and prototypes for the open hashing.
\* ************************************************************************** */

#ifndef _OHASH_H_
#define _OHASH_H_    1


#include "hashes.h"


/******************************    stuctures    *******************************/

   struct nodetype{              /* to hold the file data and treelinks */
      int intvalue,
      numnode;
      struct nodetype    *next;
   };

   typedef struct nodetype hashnode;

   struct otabtype{
      hashnode **hashtab;    /* array of pointers to nodes */
      int tabsize,                            /* tablesize */
      filled,                /* number of filled slots */
      longest;                  /* longest linked list */
   };

   typedef struct otabtype open_hashtable;

/*********************      function prototypes     ***************************/

   open_hashtable Init_OpenHashTable(int ts);
/*  Takes the tablesize, mallocs space and initializes the tabsize to
    table size, the filled count to zero, and the longest linked list
    to zero.  Returns the table.  */

   int Hash_OpenHashTable(open_hashtable *H, int r);
/*  Takes pointer to table and the value to be hashed;
    returns the hash index.  */

   int Find_OpenHashTable(open_hashtable *H, int r);
/*  Takes table and the value to be found; returns TRUE if found.  */
/* This function is not really necessary to this program b/c data file
   will contain no duplicates - however, I wanted to wirte it for the
   logic, and in keeping with a more normal hash process. */

   int Insert_OpenHashTable(open_hashtable *H, int r);
/*  Takes the hash table and the value to be inserted;
    calls Hash_OpenHashTable and Find_OpenHashTable;
    post condition - pointer to new node has been inserted in hash table.  */

   void Free_OpenHashTable(open_hashtable *H);
/*  Takes table and and frees the space allocated for it and all the
    pointers in it */

   int OutputStats_Open(open_hashtable *H);
/* Takes the hash table and output the statistics:  # of filled slots
   of the table, percentage filed, longest list length, and average
   list length. */

   int OpenHash(char *input, int ts);
/* Takes pointer to the file pointer and table size; reads in a
   file of non- duplicating integers, creates hash table and prints
   statistics. */

#endif
/*******************************   end ohash.h   ******************************/

