/* ************************************************************************** */
/*      Bettina McCormick, January 1998, CSIII, Dr. Leeson, Assignment #1     */
/*                                                                            */
/*       Huffman Code Compression Project  - Due Date: February 9, 1998       */
/*                                                                            */
/*          heap.h - Version 2.2 - last updated January 30, 1998              */
/*                                                                            */
/*                   Header file for Huffman Heap project -                   */
/*         contains structure declarations, and function prototypes           */
/*                                                                            */
/*                                                                            */
/* ************************************************************************** */


#ifndef _HEAP_H_
#define _HEAP_H_    1

#include <stdio.h>
#include <string.h>
#include <stdlib.h>


/* #define DEBUG */ 
#define   MAXSTRING            25             /* maximum lenth of file string */
#define   MAXARRAY            128               /* maximum size for freqtable */
#define   MAXCODE              32             /* maximum lenth of code string */
#define   BYTE1                 8                     /* for bit manipulation */

/******************************    stuctures    *******************************/

   struct nodetype{                       /* to hold the file data and treelinks */
      char 			     cdata;
      unsigned long int  fvalue;
      char 			     scode[MAXCODE];
      struct nodetype    *leftc;
      struct nodetype    *rightc;
   };

   typedef struct nodetype node;

   struct heaptype {            /* to hold the nodes in a heap implementaion */
      node *heapary[MAXARRAY];                 /* array of pointers to nodes */
      int hcount;                          /* to hold value of items in heap */
   };

   typedef struct heaptype heap;

   struct codetype{                    /* to hold Huffman code for each char */
      char   codestring[MAXCODE];
   };

   typedef struct codetype code;


/*********************      function prototypes     ***************************/

   void HeapInit (heap *H);
/* pointer to heap passed - precondition heap not yet used;
	postcondition: heap count set to zero */

   int HeapCount(heap *H);
/* pointer to heap passed - returns size of heap */

   void HeapInsert (heap *H, node *ptr, int newindex);
/* pointer to heap, pointer to node, and position in array passed -
	inserts new node in heap */

   void HeapDisplay (heap *H, int index);
/* displays heap for me */

   void PreorderTraversal (node *N);
/* displays tree for me */

   void Swap(heap *H, int top, int bottom);
/* pointer to heap, two positions in array passed -
	postcondition: two nodes in positions passed are swapped in heap */

   void SettleUp(heap *H, int newindex);
/* pointer to heap, position in array passed - calls swap & itself;
	postcodition: heap is settled in relationship order - every node is
	"more powereful then its children and "less powerful" than its parent
	(smallest freq value is "powerful" in this heap) */

   node *DeleteRoot(heap *H);
/* pointer to heap passed - calls swap & settledown;
	precondition: heap as more than one node;
	postcondition: root node is removed from heap and pointer to it is returned;
	heap is settled in relationship order  */

   void SettleDown(heap *H, int child, int parent);
/* pointer to heap, two positions in array passed - calls swap & itself;
	postcodition: heap is settled in relationship order - every node is
	"more powereful then its children and "less powerful" than its parent
	(smallest freq value is "powerful" in this heap) */

   void RetrieveCode(node *ptr, char C1[MAXCODE], code CD1[MAXARRAY]);
/* pointer to node, array of char & array of strings passed;
	tree is traversed and code is concatonated ans stored to array of
	strings corresponding with ascii value */

   void bit_print (unsigned char a);
/* displays bits for me */

   void DecodeNode(unsigned long int *L, node *P, FILE *infp, FILE *outfp);
/* traverses the codetree recursively the leaf of the code to the out file */
#endif
/*************************************end heap.h*******************************/
