/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600

   Simulator Project    Original Design:  Dr. David Workman
   Revised  Tim Hughey  Mark Stephens
   Could stand some more revisions...maybe I'll do an independent study!
   
   OBJECTIVE 2

   obj2.c - Version 1.3 - created February 2, 1999
								- last updated April 25, 1999

	2nd revision - submitted for obj3
	3rd revision - submitted for obj4/5
****************************************************************************/
/***************************************************************************
							my index of obj 2 funtions
void
Boot(void)

void
Get_Instr( int pgmid, struct instr_type *instr )

void
Cpu(void )

void
XPGM(struct state_type *state)

int
Mu(void)

void
SetMAR( struct addr_type *addr )

int
Fetch(struct instr_type *instr)

int
Read(struct instr_type *instr)

int
Write(struct instr_type *instr)

void
Display_pgm( struct segment_type *segtab, int numseg, struct pcb_type *pcb)

****************************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"

/*
#define DEBUG2
#define DEBUG2A
#define DEBUG_LIST
*/

#ifdef DEBUG2
   FILE *dbg2_fp;  /* for Boot function */
#endif

#ifdef DEBUG2A
   FILE *dbg2a_fp; /* for XPGM, CPU et al */
#endif

#define     MAXOP    6     /* max number of opcodes - for 'for-looping' */
#define     TRUE     1
#define     FALSE    0

#define  FAULT    -1    /* negative value returned if fault occurs */
#define  NOFAULT     1    /* positive value returned if no fault occurs */

   void
   Boot(void)
   /* ------------------------------------------------------------------------*/
   /* Boot() reads in the file boot.dat to load the kernel and initialize     */
   /* MEMMAP for the program execution.  The upper half of MEMMAP always      */
   /* holds the address map for the operating system.                         */
   /*    IE: MEMMAP[MAXSEGMENTS..2*MAXSEGMENTS-1]                             */
   /* The PROGRAM and SEGMENT statements are used to initialize the           */
   /* appropriate entries in MEMMAP.  The actual Kernal script is loaded into */
   /* MEM at absolute memory location 0.  The FreeMem list and TotalFree must */
   /* be updated as the program is loaded to account for the region of MEM    */
   /* that is occupied by the kernel.                                         */
   /*                                                                         */
   /* The format of boot.dat is the same as the other "program.dat" files.    */
   /* To load the OS program, Boot() calls the Get_Instr() routine to read    */
   /* and process each line in the data file.  Once the line is read, it is   */
   /* then stored in MEM at the appropriate absolute memory address.  Once the*/
   /* entire OS program is loaded, Boot() should call Display_pgm() to echo   */
   /* the contents of MEM to the output file.                                 */
   /*                                                                         */
   /* SPECIAL NOTE:  Get_Instr() will be used by the Loader() in objective 3  */
   /* ------------------------------------------------------------------------*/
   {
   
      int   segnum,           /* to hold value of # of Segments for for loop */
      tmp_accbits,      /* temp variable for casting */
      index,
      count,
      i, j;             /* for incrementation */
   
      char    boot_ident[15];     /* temp variable for scanning */
   
      unsigned long    tmp_addr = 0;/* temp variable for incremting membase */
   
      struct instr_type tmp_instr, *tmp_ptr2instr; /*node & pointer */
   
      struct seg_list  tmp_listnode, *tmp_ptr2node; /*node & pointer */
   
   /* start  ---------------------------------------------------------------*/
      if( OBJECTIVE != 2 ) 
         return;  /* Boot() will be active only for OBJ#2 */
   
   
   /* scan first variable-------------------------------------------------------*/
      fscanf(PROGM_FILE[BOOT],"%s",boot_ident);
      if (strlen(boot_ident) == 0)
      { printf("identifier is empty \n\n");
         exit(0);
      }
      if (isalpha(boot_ident[0]))
         My_strupr(boot_ident);  /* change case to upper */
      if(!strcmp(boot_ident,"PROGRAM"))
      /* scan segnum----------------------------------------------------------------*/
         fscanf(PROGM_FILE[BOOT],"%d",&segnum);
   #ifdef DEBUG2
      printf("this is the # of Segs - %d -boot: obj2\n", segnum);
      printf("1st Freemem->segsize = %u -boot: obj2\n",FreeMem->segsize);
   #endif
   /* scan seg info into MEMMAP---------------------------------------------------*/
      for (j=0; j < segnum; j++)
      {
         fscanf(PROGM_FILE[BOOT],"%s",boot_ident);
         if (strlen(boot_ident) == 0)
         { printf("identifier is empty \n\n");
            exit(0);
         }
         if (isalpha(boot_ident[0]))
            My_strupr(boot_ident);  /* change case to upper */
         if(!strcmp(boot_ident,"SEGMENT"))
         {
            fscanf(PROGM_FILE[BOOT],"%u", &MEMMAP[j + MAXSEGMENTS].seglen);
            fscanf(PROGM_FILE[BOOT],"%X", &tmp_accbits);
            MEMMAP[j + MAXSEGMENTS].accbits = tmp_accbits;
            MEMMAP[j + MAXSEGMENTS].membase = tmp_addr;
         
            tmp_addr = tmp_addr + MEMMAP[j + MAXSEGMENTS].seglen;
         
         /* update totalFree and FreeMem-------------------------------------------------*/
            FreeMem->segsize = (FreeMem->segsize-MEMMAP[j+MAXSEGMENTS].seglen);
            FreeMem->segptr = tmp_addr;
            TotalFree = (TotalFree - MEMMAP[j+MAXSEGMENTS].seglen);
         
         #ifdef DEBUG2
            printf("MEMMAMP[%d].seglen = %u -boot: obj2\n",(j + MAXSEGMENTS),
                  MEMMAP[j + MAXSEGMENTS].seglen);
            printf("MEMMAMP[%d].accbits = %d -boot: obj2\n",(j + MAXSEGMENTS),
                  MEMMAP[j + MAXSEGMENTS].accbits);
            printf("MEMMAMP[%d].membase = %u -boot: obj2\n",(j + MAXSEGMENTS),
                  MEMMAP[j + MAXSEGMENTS].membase);
            printf("Freemem->segsize = %u -boot: obj2\n", FreeMem->segsize);
            printf("Freemem->segptr = %u -boot: obj2\n", FreeMem->segptr);
            printf("Freemem->segptr = %u -boot: obj2\n", TotalFree);
         #endif
         } /* END IF "SEGMENT" */
      } /* end for segnum times fill memap */
      tmp_ptr2instr = &tmp_instr; /* allocate space */
   
   /* call GetInstr-----------------------------------------------------------------*/    
      for (i = 0; i < segnum; i++)
      {
         count = MEMMAP[i + MAXSEGMENTS].membase;
         for (j = 0; j < MEMMAP[i + MAXSEGMENTS].seglen; j++)
         {
            Get_Instr(BOOT, tmp_ptr2instr);
            MEM[count] = *tmp_ptr2instr;
            index = MEM[count].opcode;
         #ifdef DEBUG2
            if (index < MAXOP)
            {
               printf("MEM[%d].opcode = %s -boot: obj2\n",count,
                     opidtab[index]);
            }
            else if (index >= MAXOP)
            {
               index = (index - MAXOP);
               printf("MEM[%d].opcode = %s -boot: obj2\n",count,
                     devtable[index].devid);
            }
         #endif
            count++;
         } /* end 2nd for -each instruction */
      } /* end 1st for -each segment */
   /* call Display_pgm------------------------------------------------------------*/
      Display_pgm( MEMMAP, segnum, *termtable);
   
   } /* end Boot */

   void
   Get_Instr( int pgmid, struct instr_type *instr )
   /* ------------------------------------------------------------------------*/
   /* This function reads the next instruction from file (fp) into (instr)    */
   /* The external file (fp) is PROGM_FILE[pgmid].  The format of the file is */
   /* a series of statements of the form:  OPCODE  x  y  z                    */
   /* where the form and type of the operands (x,y,z) depend on OPCODE        */
   /* Each instruction starts on a new line.                                  */
   /*                                                                         */
   /*  OBJECTIVE 2 will read from boot.dat ( PROGM_FILE[BOOT] )               */
   /* ------------------------------------------------------------------------*/
   {
      char     instr_ident[10],/* tmp to hold scanned value for opcode */
      tempstring[10];   /* tmp to hold scanned value for operand */
   
      int      i,               /* for incrementation */
      index,
      tempseg,           /* tmp to hold scanned value for segment */
      opflag = FALSE;  /* set TRUE if value == opidtab value */
   
      unsigned int   tempoff;     /* tmp to hold scanned value for offset */
               #ifdef DEBUG2
      printf("entered Get_instr\n");
         #endif
      fscanf(PROGM_FILE[pgmid],"%s",instr_ident);
   
      if (strlen(instr_ident) == 0)
      { printf("identifier in Get_Instr is empty \n\n");
         exit(0);
      }
               #ifdef DEBUG2
      printf("Get_instr do I get here?\n");
         #endif
      if (isalpha(instr_ident[0]))
         My_strupr(instr_ident);  /* change case to upper */
               #ifdef DEBUG2
      printf("Get_instr after upper instr = %s?\n", instr_ident);
         #endif
      for (i = 0; i <= MAXOP; i++)
      {                          /* for each opcode */
         if (i == MAXOP)
         {
               #ifdef DEBUG2
            printf("Get_instr (i == MAXOP)?\n");
         #endif
            break;
         }
      
         if( !strcmp(instr_ident,opidtab[i]))
         {
            instr->opcode = i;
         #ifdef DEBUG2
            printf("instr.opcode=%s -get_inst: obj2\n", opidtab[instr->opcode]);
            printf("it matches %d -get_inst: obj2\n", i);
         #endif
            break;
         }/* end if opidtab */
      }/* end for each opcode in event opid table */
   
      if (i == MAXOP)
      {
         for (i = 0; i < DEVSIZE; i++)
         {                        /* if device */
            if(!strcmp(instr_ident,devtable[i].devid))
            {
               index =  (MAXOP + i );
               instr->opcode = index;
            #ifdef DEBUG2
               printf("opcode=%s -get_inst: obj2\n", devtable[i].devid);
               printf("opcode # is %d -get_inst: obj2\n", instr->opcode);
            #endif
            /******* determine the operand portion *******/
               fscanf(PROGM_FILE[pgmid],"%s",tempstring);
               instr->operand.bytes = atoi(tempstring);
            #ifdef DEBUG2
               printf("operand = %d \n",instr->operand.bytes);
            #endif
            }/* end if device */
         }/* end for each event in event id table */
      }/* end if */
      /******* determine the operand portion *******/
      switch(i)
      {
      case OP_SIO:
      case OP_WIO:
      case OP_END:
         fscanf(PROGM_FILE[pgmid], "%lu", &instr->operand.burst);
         break;
      case OP_JUMP:
      case OP_REQ:
         fscanf(PROGM_FILE[pgmid], " [%d, %u]",
               &instr->operand.address.segment,
               &instr->operand.address.offset);
         break;
      case OP_SKIP:
         fscanf(PROGM_FILE[pgmid], "%d", &instr->operand.count);
         break;
      default:
         fscanf(PROGM_FILE[pgmid], "%lu", &instr->operand.bytes);
         break;
      }  /* end switch */
          #ifdef DEBUG3
         printf("Exit Get_instr\n\n");
         #endif
   } /* end Get_Instr */

   void
   Cpu(void )
   /* ----------------------------------------------------------------------- */
   /*     This function simulates the Central Processing Unit.                */
   /*                                                                         */
   /*     The CPU:                                                            */
   /*         1. Fetch()'s the instruction from Memory (MEM)                  */
   /*         2. Interprets it.                                               */
   /*         3. Creates a future event based on the type of instruction and  */
   /*            inserts the event into the event queue.                      */
   /*                                                                         */
   /*     The first fetch from memory is based on CPU.pc.                     */
   /*     Instructions that create events are:                                */
   /*         1. WIO                                                          */
   /*         2. SIO                                                          */
   /*         3. END                                                          */
   /*                                                                         */
   /*     The SKIP and JUMP instructions are executed in "real time" until    */
   /*     one of the other instructions causes a new event.                   */
   /*                                                                         */
   /*     Addressing faults may be generated by a call to Fetch() or Write()  */
   /*     SetMAR() is called to define the next memory location for a         */
   /*     Fetch() or Write().                                                 */
   /* ----------------------------------------------------------------------- */
   /*     (1)  SetMAR(&CPU.pc);                                               */
   /*     (2)  Fetch(&IREG);                                                  */
   /*          If Fetch() returns negative, a FAULT has occurred.  In this    */
   /*          case, Cpu() returns.  Otherwise, continue.                     */
   /*     (3)  Decode IREG and execute the instruction.                       */
   /*          (a) For SIO, WIO, and END instructions, compute the deltaT     */
   /*              defined by the operand, add to CLOCK to get future event   */
   /*              time, and add this new event to the event list.            */
   /*              Increment CPU.pc.offset by 2 and return.                   */
   /*              NOTE: you will find the function Burst_time() in SIMLATOR.C*/
   /*              of use when converting from CPU cycles to simulation time. */
   /*                                                                         */
   /*          NOTE: For OBJECTIVE 2 you should use a special agent code (0)  */
   /*                to identify the BOOT program.  For all other OBJECTIVES  */
   /*                the agent code should be: CPU.actvpcb->termnl+1.         */
   /*                                                                         */
   /*          (b) FOR SKIP, evaluate the operand.  If the operand of IREG    */
   /*              changes, you must update MEM by a call to Write() with     */
   /*              the modified IREG.  Increment CPU.pc.offset by 2 if the    */
   /*              next instruction is to be skipped and repeat from step (1).*/
   /*              Otherwise, Fetch() the JUMP instruction at CPU.pc.offset+1.*/
   /*              Execute the JUMP by placing its operand in CPU.pc          */
   /*              and repeat from step (1).                                  */
   /* ----------------------------------------------------------------------- */
   {
      static int        cntr = 0;
   
      struct instr_type IREG;
      int   doneflag = FALSE,
      fetch_val,     /* val returned by fetch */
      Event,         /* val for event */
      A;       /* val for agent */
   
      struct simtime B_time;  /* for converted burst time */
   
          #ifdef DEBUG3
         printf("Entered CPU\n");
         #endif
      if (OBJECTIVE == 2)
         A = 0;
      else
         A = (CPU.actvpcb->termnl + 1);
   
      while (doneflag == FALSE)
      {
         SetMAR(&CPU.pc);
      
      #ifdef DEBUG2A
         printf("1setmar = [%d,%d] CPU-obj2\n", CPU.pc.segment, CPU.pc.offset);
      #endif
      
         fetch_val = Fetch(&IREG);
      #ifdef DEBUG2A
         printf( "fetch_val = %d cpu-OBJ2\n", fetch_val);
      #endif
         if (fetch_val < 0)
            return;
         else
         {
         #ifdef DEBUG2A
            printf("instr opcode = %d  cpu-OBJ2\n", IREG.opcode);
         #endif
            switch(IREG.opcode)
            {
            case OP_SIO:
               Event = SIO;
               Burst_time(&B_time, IREG.operand.burst);
               Add_time(&B_time, &CLOCK);
               Add_event(&CLOCK, Event, A);
               doneflag = TRUE;
               cntr++;
            #ifdef DEBUG2A
               printf("\nin cpu - after add event sio -obj2\n");
               printf("event=%d; agent =%d clock [%u,%u] CPU-obj2\n",
                     Event, A, CLOCK.seconds, CLOCK.nanosec);
            #endif
            #ifdef DEBUG_LIST
               Mylist();
            #endif
               CPU.pc.offset = CPU.pc.offset + 2;
               break;
            case OP_WIO:
               Event = WIO;
               Burst_time(&B_time, IREG.operand.burst);
               Add_time(&B_time, &CLOCK);
               Add_event(&CLOCK, Event, A);
               doneflag = TRUE;
               cntr++;
            #ifdef DEBUG2A
               printf("\nin cpu - after add event wio -obj2\n");
            #endif
            #ifdef DEBG_LIST
            Mylist();
            #endif
               CPU.pc.offset = CPU.pc.offset + 2;
               break;
            case OP_END:
               Event = PGMEND;
               Burst_time(&B_time, IREG.operand.burst);
               Add_time(&B_time, &CLOCK);
               Add_event(&CLOCK, Event, A);
               doneflag = TRUE;
               cntr++;
            #ifdef DEBUG2A
               printf("\nin cpu - after add event end -obj2\n");
            #endif
            #ifdef DEBG_LIST
            Mylist();
            #endif
               CPU.pc.offset = CPU.pc.offset + 2;
               break;
            case OP_SKIP:
               if (IREG.operand.count > 0)
               {
                  IREG.operand.count--;
                  Write(&IREG);
                  CPU.pc.offset = CPU.pc.offset + 2;
               }
               else
                  CPU.pc.offset = CPU.pc.offset + 1;
               break;
            case OP_JUMP:
            case OP_REQ:      
               CPU.pc.segment = IREG.operand.address.segment;
               CPU.pc.offset = IREG.operand.address.offset;
            default:
               exit;
               break;
            } /* end switch */
         }/* while (doneflag == FALSE) */
      }/* end else */
          #ifdef DEBUG3
         printf("Exit CPU\n\n");
         #endif
   
   }/* end Cpu */

   void
   XPGM(struct state_type *state)
   /* ----------------------------------------------------------------------- */
   /*  This function simulates a priviledged instruction causing a context    */
   /*  switch placing a user program in execution.  It does this by copying   */
   /*  (state->mode) into CPU.mode and (state->pc) into CPU.pc.  After the    */
   /*  state of the CPU has been redefined, the CPU resumes execution at      */
   /*  CPU.pc -- this is implemented by simply calling the function, Cpu().   */
   /* ----------------------------------------------------------------------- */
   {
      #ifdef DEBUG2 /*
      if( (dbg2_fp = fopen("DEBUG/dbg_2.dat","w")) == NULL  )
      { printf("dbg_2.dat file did not open! \n");
         exit(0);
      }
    */
   #endif
   
   #ifdef DEBUG2A/*
      if( (dbg2a_fp = fopen("DEBUG/dbg_2a.dat","w")) == NULL  )
      { printf("dbg_2.dat file did not open! \n");
         exit(0);
      } */
   #endif
   
   #ifdef DEBUG2A
      printf("state = [%d,%d] XPGM-obj2\n", state->pc.segment, state->pc.offset
            );
         #endif
      #ifdef DEBG_LIST
   Mylist();
   #endif
   
      CPU.mode = state->mode;
      CPU.pc.segment = state->pc.segment;
      CPU.pc.offset = state->pc.offset;
      Cpu();
   } /* end XPGM */

   int
   Mu(void)
   /* ----------------------------------------------------------------------- */
   /*  This function simulates the address translation hardware of the Memory */
   /*  Unit.  It uses the contents of MAR = [s,d] as the logical address to   */
   /*  be translated to a physical address, x.                                */
   /*                                                                         */
   /*  (0)  First compute the effective entry in MEMMAP.                      */
   /*       Set  SEG = s + CPU.mode*MAXSEGMENTS.  This forces the upper half  */
   /*       of the MEMMAP to be used if CPU.mode == 1 (priviledged mode) and  */
   /*       the lower half if CPU.mode != 1 (user mode).                      */
   /*                                                                         */
   /*  (1)  If MEMMAP[SEG].accbits == 0x00, then generate an SEGFAULT event   */
   /*       at the current CLOCK time and add it to the event_list using      */
   /*       Add_event(). Return -1.  Agent == CPU.actvpcb->termnl+1.          */
   /*                                                                         */
   /*  (2)  If MEMMAP[SEG].seglen <= d, then generate an ADRFAULT event at the*/
   /*       current CLOCK time and add it to the event_list.  Return -1.      */
   /*                                                                         */
   /*  (3)  return  x = MEMMAP[SEG].membase + d.                              */
   /* ----------------------------------------------------------------------- */
   {
      int   E,    
      A,
      SEG,     /* segment index */     
      phys_addr;  /* physical address returned */
   
      SEG = MAR.segment + (CPU.mode * MAXSEGMENTS);
   
      if (OBJECTIVE == 2)
         A = 0;
      else
         A = (CPU.actvpcb->termnl + 1);
   
      if (MEMMAP[SEG].accbits == 0x00)
      {
         Add_event(&CLOCK, SEGFAULT, A);
         return FAULT;
      } /* end 1st if */
      if (MEMMAP[SEG].seglen <= MAR.offset)
      {
         Add_event(&CLOCK, ADRFAULT, A);
         return FAULT;
      } /* end 2nd if */
   
      phys_addr = (MEMMAP[SEG].membase + MAR.offset);
   
      return phys_addr;
   
   }/* end Mu */


   void
   SetMAR( struct addr_type *addr )
   /* ----------------------------------------------------------------------- */
   /*  This function sets a global variable MAR representing the Memory       */
   /*  Address Register with the value of (addr) and returns.  This function  */
   /*  must becalled to define the logical MEM address of the next Fetch(),   */
   /*  Read(), or Write() operation on memory.                                */
   /* ----------------------------------------------------------------------- */
   {
      MAR.segment = addr->segment;
      MAR.offset = addr->offset;
   #ifdef DEBUG2A
      printf("setmar = [%d,%d] setmar-obj2\n", MAR.segment, MAR.offset);
   #endif
   }   /* end SetMAR */


   int
   Fetch(struct instr_type *instr)
   /* ----------------------------------------------------------------------- */
   /*  This function calls Mu() to validate and map the logical address in MAR*/
   /*  to a physical address.  Mu() will return a negative value if some kind */
   /*  of FAULT was generated.  In this case, Fetch() returns -1.  If Mu()    */
   /*  returns a non-negative value, say x, then Fetch sets *instr = MEM[x]   */
   /*  and returns +1.                                                        */
   /* ----------------------------------------------------------------------- */
   {
      int fetch_mu_val;
   
      fetch_mu_val = Mu();
   
   #ifdef DEBUG2A
      printf("fetched instr MEM[%d] fetch-obj2\n", fetch_mu_val);
   #endif
      if (fetch_mu_val < 0)
      {
         return FAULT;
      }
      else
      {
         *instr = MEM[fetch_mu_val];
         return NOFAULT;
      }  
   }/* end Fetch */

   int
   Read(struct instr_type *instr)
   
   /* ----------------------------------------------------------------------- */
   /*  This function calls Mu() to validate and map the logical address in MAR*/
   /*  to a physical address.  Mu() will return a negative value if some kind */
   /*  of FAULT was generated.  In this case, Read() returns -1.  If Mu()     */
   /*  returns a non-negative value, say x, then Read sets *instr = MEM[x]    */
   /*  and returns +1.                                                        */
   /* ----------------------------------------------------------------------- */
   {
      int read_mu_val;
   
      read_mu_val = Mu();
      if (read_mu_val < 0)
      {
         return FAULT;
      }
      else
      {
         *instr = MEM[read_mu_val];
         return NOFAULT;
      }
   } /* end Read */

   int
   Write(struct instr_type *instr)
   /* ----------------------------------------------------------------------- */
   /*  This function calls Mu() to validate and map the logical address in MAR*/
   /*  to a physical address.  Mu() will return a negative value if some kind */
   /*  of FAULT was generated.  In this case, Write() returns -1.  If Mu()    */
   /*  returns a non-negative value, say x, then Write sets MEM[x] = *instr   */
   /*  and returns +1.                                                        */
   /* ----------------------------------------------------------------------- */
   {
   
      int write_mu_val;
   
      write_mu_val = Mu();
      if (write_mu_val < 0)
      {
         return FAULT;
      }
      else
      {
         MEM[write_mu_val] = *instr;
         return NOFAULT;
      }
   }
/* end Write */

   void
   Display_pgm( struct segment_type *segtab, int numseg, struct pcb_type *pcb)
   /* ----------------------------------------------------------------------- */
   /* This function will dump the contents of a program to the *.out file.    */
   /* Use this function after every program load.                             */
   /* Use segtab, segment table * to locate each segment.  Use the provided   */
   /* sample output in intro.doc as an example of the format of the dump      */
   /* and what information should be output.                                  */
   /*                                                                         */
   /* For OBJECTIVE 2, pcb will be null. So print the name as "BOOT"          */
   /* ----------------------------------------------------------------------- */
   {
   
      char  *dummy1 = "BOOT";
      int   i, j,       /* for incrementation */
      tmpcd = 0;
      unsigned long     index;      /* for index to MEM */
   
   
      fprintf(simout, "        ACCBITS: %x  LENGTH: %2u\n",
             segtab->accbits,segtab->seglen);
      fprintf(simout, "        MEM ADDR  OPCODE  OPERAND\n");
      fprintf(simout, "        --------  ------  -------\n");
   
      for(j = 0; j < numseg; j++)
      {
         index = segtab->membase + j;
         tmpcd = MEM[index].opcode;
      
         switch(tmpcd)
         {
         case OP_SIO:
         case OP_WIO:
         case OP_END:
            fprintf(simout, " \t%5lu  %-6s  %-5lu\n", index,
                   opidtab[tmpcd], MEM[index].operand.burst);
            break;
         case OP_SKIP:
            fprintf(simout, " \t%5lu  %-6s  %-5lu\n", index,
                   opidtab[tmpcd], MEM[index].operand.count);
            break;
         case OP_JUMP:
         case OP_REQ:
            fprintf(simout, "  \t%5lu  %-6s  [%2d, %2d]\n", index,
                   opidtab[tmpcd], MEM[index].operand.address.segment,
                   MEM[index].operand.address.offset);
            break;
         default:
            fprintf(simout, "  \t%5lu  %-6s  %-5lu\n", index,
                   devtable[(tmpcd - MAXOP)].devid, MEM[index].operand.bytes);
            break;
         }  /* End of switch(opcode) */
      } /* End of for loop */
   } /* end Display_pgm */

/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
   End   OBJECTIVE 2
****************************************************************************/
