/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600

   Simulator Project    Original Design:  Dr. David Workman
   Revised  Tim Hughey  Mark Stephens

   OBJECTIVE 3

   obj3.c - Version 1.8b   - created March 19, 1999
					  - last updated April 28, 1999

	1st revision - submitted for obj4/5
****************************************************************************/
/***************************************************************************
							my index of obj 3 funtions
void
Get_Script( struct pcb_type *pcb )

void
Logon_Service()

int
Next_pgm(struct pcb_type *pcb)

void
Get_memory( struct pcb_type *pcb )

int
Alloc_seg( int len )

void
Loader( struct pcb_type *pcb )

void
Dealloc_pgm(struct pcb_type *pcb)

void
Dealloc_seg( int base, int len )

void
Merge_seg()

void
End_Service()

void
Abend_Service()
****************************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"

/*
#define DEBUG3
#define DEBUG_LIST
#define DEBUG6
*/

#define TRUE   1
#define FALSE  0

#ifdef DEBUG3
   FILE *dbg3_fp;
#endif

/********************* Objective 3 functions *********************************/


   void
   Get_Script( struct pcb_type *pcb )
   /* -------------------------------------------------------------------------/
   /     This function reads a script from script.dat.  The script read is     /
   /     returned as a string of integers from the set { EDITOR, PRINTER,      /
   /     COMPILER, LINKER, USER, LOGOFF}.  LOGOFF marks the end of the string  /
   /     and is generated when a LOGOFF is encountered in the SCRIPT.DAT       /
   /     file.  The SCRIPT.DAT file is free form using blanks to delimit the   /
   /     tokens: EDITOR, PRINTER, COMPILER, LINKER, USER and LOGOFF.  Each     /
   /     script ends with a LOGOFF and must contain at least one other token.  /
   /                                                                           /
   /     NOTE:                                                                 /
   /     pcb->script = (int *)calloc( MAXSCRIPT+1, sizeof( int ));             /
   /     pcb->pgmid  = -1;  <--- indicates start of script                     /
   / ------------------------------------------------------------------------ */
   {
      int  i,
      temp = -1,
      *myscript;    /* array of int */
      char scr_ident[10] = "NEW";
         #ifdef DEBUG3
      printf("Entered Get_script OBJ3\n");
   #endif
   
      pcb->pgmid = -1;
      myscript = (int *)calloc(MAXSCRIPT + 1, sizeof(int));
      pcb->script = (int *)calloc(MAXSCRIPT + 1, sizeof(int));
   
      fprintf(simout, "\n         SCRIPT FOR PROCESS U%03d IS:\n", AGENT);
      fprintf(simout,"         ");
   
      for (i = 0; temp != LOGOFF && i <= MAXSCRIPT; i++)
      {
         fscanf(scriptfp, "%s", scr_ident);
         if(!strcmp(scr_ident, pgmidtab[EDITOR]))
            myscript[i] = EDITOR;
         else
            if(!strcmp(scr_ident, pgmidtab[PRINTER]))
               myscript[i] = PRINTER;
            else
               if(!strcmp(scr_ident, pgmidtab[COMPILER]))
                  myscript[i] = COMPILER;
               else
                  if(!strcmp(scr_ident, pgmidtab[LINKER]))
                     myscript[i] = LINKER;
                  else
                     if(!strcmp(scr_ident, pgmidtab[USER]))
                        myscript[i] = USER;
                     else
                        if(!strcmp(scr_ident, pgmidtab[LOGOFF]))
                           myscript[i] = LOGOFF;
      
         fprintf(simout, "%s ", scr_ident);
         temp = myscript[i];
      } /* End for */
      pcb->script = myscript;
   
      fprintf(simout,"\n\n");
         #ifdef DEBUG3
      printf("Exit Get_script OBJ3\n\n");
   #endif
   } /* End Get_Script */

   void
   Logon_Service()
   /* ----------------------------------------------------------------------- */
   /*                     This function services LOGON events.                */
   /*                                                                         */
   /*     (1)  Allocate pcb and save pointer in terminal table at the index   */
   /*          given by: AGENT - 1.  Use calloc( 1, sizeof( struct pcb_type ))*/
   /*          so that the allocated storage is set to zero.                  */
   /*          Initialize (status) to 'N';.                                   */
   /*                     (termnl) to AGENT - 1;                              */
   /*                     (rbwait) to NULL;                                   */
   /*                     (rblist) to NULL;                                   */
   /*                                                                         */
   /*     (2)  Call Get_Script( pcb ) to initial the process (script) and     */
   /*          (pgmid).                                                       */
   /*                                                                         */
   /*     (3)  Call Next_pgm( pcb ) to allocate and load first program.       */
   /*                                                                         */
   /*     (4)  If (OBJECTIVE > 3) then                                        */
   /*             SCHED_SW = CPU_SW = CPU.actvpcb == NULL ? 1 : 0;            */
   /* ----------------------------------------------------------------------- */
   {
      struct pcb_type *mypcb;
   
      mypcb = (struct pcb_type*) calloc(1, sizeof(struct pcb_type));
      mypcb->status  = 'N';
      mypcb->termnl  = AGENT - 1;
      mypcb->wait    = NULL;
      mypcb->firstrb = NULL;
      mypcb->lastrb  = NULL;
      mypcb->logont = CLOCK;
   
   #ifdef DEBUG3/*
   if( (dbg3_fp=fopen("DEBUG/dbg_3.dat","w"))==NULL)
   {
   printf("DEBUG.dat file does not exist! \n");
   exit(0);
   } */
   #endif
   
   #ifdef DEBUG3
      printf("Entered Logon_service? OBJ3\n");
   #endif
   
      Get_Script(mypcb);
   
      Next_pgm(mypcb);
   
      termtable[AGENT-1] = mypcb;  /* assign termtable array my pcb */
      sprintf(termtable[AGENT - 1]->user, "U%03d", AGENT); /* fill user string*/
   
   /************************  for obj 4, 5 & 6  ********************/
      if(OBJECTIVE > 3)
         SCHED_SW = CPU_SW = CPU.actvpcb == NULL ? 1 : 0;
   #ifdef DEBUG3
      printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
   #endif
   #ifdef DEBUG3
      printf("Exit Logon_service OBJ3\n\n");
   #endif
   
   } /* End Logon_Service() */

   int
   Next_pgm(struct pcb_type *pcb)
   /* ----------------------------------------------------------------------- */
   /*  This function makes the transition to the next program in the script   */
   /*  for (pcb), if there is one. A 1 is returned if the transition to the   */
   /*  next program is successful, a 0 otherwise. The transition is possible  */
   /*  only if the RB-list for the current program is empty and the script    */
   /*  is not empty.                                                          */
   /*                                                                         */
   /*                                                                         */
   /*  (1) if pcb->pgmid >= 0 && pcb->firstrb == NULL, then deallocate the    */
   /*      current program by calling Dealloc_pgm( pcb );                     */
   /*                                                                         */
   /*                                                                         */
   /*  (3) if( pcb->script[++pcb->pgmid] == LOGOFF )                          */
   /*        (a) print a banner message to *.OUT that process Uxxx has        */
   /*            logged off!                                                  */
   /*        (b) set pcb->status = 'T';                                       */
   /*        (c) return(0)                                                    */
   /*                                                                         */
   /*  (4) Call Get_Memory( pcb ) to build and initialize a new segment table.*/
   /*                                                                         */
   /*  (5) Call Loader( pcb ) to load the next program;                       */
   /*                                                                         */
   /*  (6) Initialize (cpu_save) to  { 0x00, {0,0} } and set (status) to 'R'. */
   /*                                                                         */
   /*  (7) If (OBJECTIVE > 3) then Add_cpuq( pcb );                           */
   /*                                                                         */
   /*  (8) return(1);                                                         */
   /* ----------------------------------------------------------------------- */
   {
      struct simtime tempt;
	 int i;
	 int end;

	 #ifdef DEBUG3
      printf("Entered Next_pgm OBJ3\n");
      Pcb_rblist(pcb);
      printf("PCB[%d] user=%s:  pgmid=%d:  OBJ3\n",pcb->termnl,
            pcb->user, pcb->pgmid);
	 #endif

      if(pcb->pgmid >= 0 && pcb->firstrb == NULL)
      {
         Dealloc_pgm(pcb);    /* this empties the MEM */
      }
      if(pcb->firstrb != NULL)
      {
      #ifdef DEBUG3
         printf("Next_pgm - firstrb was not null.\n");
      #endif
         return(0);             /* otherwise get out of this */
      }
      i = ++pcb->pgmid;
   #ifdef DEBUG3
      printf("PCB[%d] script=%d: OBJ3\n",pcb->termnl, pcb->script[i]);
   #endif
      if(pcb->script[i] == LOGOFF)
      {
         tempt = CLOCK;
         Diff_time(&pcb->logont, &tempt);
         pcb->tlogon = tempt;
      #ifdef DEBUG3
         printf("Next_pgm if ==Logoff OBJ3\n");
      #endif
         fprintf(simout, "\n     PROCESS %s HAS LOGGED OFF!\n", pcb->user);
      #ifdef DEBUG3
	    printf("************  set status to 'T'  *************\n");
      #endif
			pcb->status = 'T';

			/**************   get time stats  ************/
			tempt = CLOCK;
			Diff_time(&pcb->readyt, &tempt);

			/****** check if end of program ******/
			end = TRUE;    /* assume it is */
			for (i = 0; i < TRMSIZE; i++)
			{
				if (termtable[i]->status != 'T')
				{
					end = FALSE;
				}    /* if not all PCB = 'T', not end */
			} /* end for each pcb */

			/******* get total CPU time stats *****/
			if (end == TRUE)
			{
				for (i = 0; i < TRMSIZE; i++)
				{       /* for each PBC */
				   Add_time(&termtable[i]->tready, &CPU.qwait);
				   Add_time(&termtable[i]->trun, &CPU.busy);
				} /* end for each pcb */
			}/* end if end of program */

	    return(0);
      }  /* End of if */
   
      Get_memory(pcb); /* get mem for next pgm */
   
      Loader(pcb);  /* load pgm */
   
   
      pcb->cpu_save.mode = 0x00;      /* set inital valueas */
      pcb->cpu_save.pc.segment = 0;
      pcb->cpu_save.pc.offset = 0;
      pcb->status = 'R';     /* ready */
   
   /************************  for obj 4, 5 & 6  ********************/
      #ifdef DEBUG3
      printf("Next_pgm about to enter Add_cpuq OBJ3\n");
   #endif
      if(OBJECTIVE > 3)
         Add_cpuq(pcb);
   
      return(1);
   #ifdef DEBUG3
      printf("Exit Next_pgm OBJ3\n\n");
   #endif
   
   }  /* End Next_pgm */

   void
   Get_memory( struct pcb_type *pcb )
   /* ----------------------------------------------------------------------- */
   /*  This function is the memory manager.  It allocates space for a new     */
   /*  program by reading a segment table from disk. The program type is given*/
   /*  by (p = pcb->script[pcb->pgmid]). The segment table length and a       */
   /*  pointer to it are passed back as (pcb->segtab_len, pcb->segtable). The */
   /*  number of segments defined for the program is given by a PROGRAM       */
   /*  statement (PROGRAM  n) in the file PROGM_FILE[p]. The length of each   */
   /*  segment is given by the n SEGMENT statements to follow in the program  */
   /*  file (SEGMENT  L   X );  L = segment length, X = access byte (hex).    */
   /*                                                                         */
   /*  Once the segment table has been allocated and constructed, memory is   */
   /*  allocated to each segment.  Caution, make sure all segments can be     */
   /*  allocated.  If not, Get_memory should fail.                            */
   /*                                                                         */
   /*  (1) read PROGRAM statement and set pcb->segtab_len                     */
   /*  (2) allocate pcb->segtable                                             */
   /*  (3) read each SEGMENT statement and fill in the access bits field      */
   /*      and the segment length field; keep a running sum of the segment    */
   /*      lengths.                                                           */
   /*  (4) compare program length with TotalFree                              */
   /*  (5) if insufficient free space, then print an error message to *.OUT   */
   /*      and exit the simulator. NOTE: you could return a flag so that      */
   /*      only the current process is aborted allowing simulation to         */
   /*      continue.                                                          */
   /*                                                                         */
   /*  (6) call Alloc_seg() for each segment;                                 */
   /*      (a) if Alloc_seg() returns a value >=0 then allocation was         */
   /*          successful and the return value denotes the segment base       */
   /*          address and should be saved in the segment table; otherwise    */
   /*      (b) call Compaction() and goto (6)                                 */
   /* ----------------------------------------------------------------------- */
   {
      char scrpt_ident[10];
   
      unsigned long tmp_accbits;
   
      int pgm,
      i,
      num_of_segs,
      seg_length,
      rtnflag = FALSE,
      pgm_length = 0,
      alloc_val = 0;
   
   #ifdef DEBUG3
      printf("entered Get_Memory \n");
   #endif
      i = pcb->pgmid;
      pgm = pcb->script[i];
   
   #ifdef DEBUG3
		printf("pgm = %d\n", pgm);
   #endif
      fscanf(PROGM_FILE[pgm], "%s %d\n", scrpt_ident, &num_of_segs);
      pcb->segtable =
         (struct segment_type *)calloc(num_of_segs, sizeof(struct segment_type));
      pcb->segtab_len = num_of_segs;
         #ifdef DEBUG3
      printf("pcb->segtab_len = %d\n", num_of_segs);
   #endif
   
      for(i = 0; i < num_of_segs; i++)
		{
			fscanf(PROGM_FILE[pgm],"%s %d %x\n", scrpt_ident, &seg_length,
               &tmp_accbits);
         pcb->segtable[i].accbits = tmp_accbits;
         pcb->segtable[i].seglen = seg_length;
         pgm_length += seg_length;
         #ifdef DEBUG3
         printf("pcb->segtable[%d].accbits = %d\n",i, tmp_accbits);
         printf("pcb->segtable[%d].seglen = %d\n",i, seg_length);
      #endif
      
      
      } /* End for */
   
   /************************* might need to change later *********************/
      if(pgm_length > TotalFree)
      {
         printf(simout,"Not enough Total free memory for this process.\n");
         rtnflag = TRUE;
         return;
      }
   
      for(i = 0; i < num_of_segs; i++)
		{
			#ifdef  DEBUG6
			printf("About to enter Alloc_seg\n");
			#endif
			fprintf(simout, "\n....... ALLOCATE SEGMENT #%d in Get_mem\n", i);
         alloc_val = -1;
			while(alloc_val < 0)
			{
			alloc_val = Alloc_seg(pcb->segtable[i].seglen);

			#ifdef  DEBUG6
			printf("Alloc_seg returns value = %d\n", alloc_val);
			#endif
         if(alloc_val >= 0)
         {
         #ifdef DEBUG3
            printf("Get_Memory pcb->segtable[%d].membase = %d\n", i, alloc_val);
         #endif
            pcb->segtable[i].membase = alloc_val;
         }
         else
         {
			#ifdef DEBUG6
         printf("Get_Memory call compact mem\n");
         #endif
            Compact_mem();    /* written in obj 6 */
			}
			} /* end while alloc_val < 0 */
      } /* End for */
   
	#ifdef DEBUG3
		printf("Exit Get_Memory \n\n");
	#endif
   } /* End Get_Memory */


   int
   Alloc_seg( int len )
   /* ----------------------------------------------------------------------- */
   /*   This function searches the list of free memory segments for a segment */
   /*   of at least length (len) and returns the address of this free segment.*/
   /*   If the request cannot be satisfied, return( -1 ).                     */
   /*                                                                         */
   /*   Assume the FreeMem list is maintain in order by base address of each  */
   /*   free segment on the list. NOTE! The base addresses of free segments   */
   /*   are integer values denoting INDEXes into the MEM array.  If MEM[i]    */
   /*   denotes the beginning of a free segment, then "return i" DO NOT       */
   /*   RETURN "&MEM[i]".                                                     */
   /*                                                                         */
   /*   If the allocated space completely consumes a free segment, then the   */
   /*   FreeMem list element for that free segment must be removed from the   */
   /*   list.  Don't forget to update the FreeMem list element from which     */
   /*   the space was taken and the variable (TotalFree).                     */
   /* ----------------------------------------------------------------------- */
   {
      int  still_looking = TRUE,
      foundflag = 0,
      notfound = -1,
      mem_index = 0;
   
      struct seg_list *tracer_cur, *ptracer;

	#ifdef DEBUG6
		printf("Entering Alloc_seg \n\n");
	#endif
      tracer_cur = FreeMem;
      ptracer = NULL;
   
   /* Look for the sufficent seg length */
   
      while((still_looking)&&(tracer_cur != NULL))
      {
         if(tracer_cur->segsize > len)
         {
            tracer_cur->segsize -= len;
            mem_index = tracer_cur->segptr;
            tracer_cur->segptr += len;
            TotalFree -= len;
            foundflag = TRUE;
            still_looking = FALSE;
         #ifdef DEBUG3
            printf("found memory big enough in Alloc_seg-obj3\n");
         #endif
            break;
         } /* End if */
         
         else if(tracer_cur->segsize == len)
         {
            mem_index = tracer_cur->segptr;
            if (ptracer == NULL)
               FreeMem = tracer_cur->next;
         
            TotalFree -= len;
            free(tracer_cur);
            foundflag = 1;
            still_looking=0;
            break;
         } /* End else if */
         else
         {
            ptracer = tracer_cur;               /* advance pointers */
            tracer_cur = tracer_cur->next;
         }
      } /* End while */
   
      if(foundflag)
      {
         return mem_index;
         #ifdef DEBUG3
         printf("found memory - index = %d\n",mem_index);
         #endif
      }
		else
		{
			return(notfound);
		}
   } /* End Alloc_Seg */

   void
   Loader( struct pcb_type *pcb )
   /* ----------------------------------------------------------------------- */
   /*   The loader reads file PROGM_FILE[pcb->script[pcb->pgmid]] where pgmid */
   /*   is the index of the next entry in the process script(pcb->script).    */
   /*   The segment table, pcb->segtable, contains the length of each segment */
   /*   and where it should load in memory.                                   */
   /*                                                                         */
   /*   Function, Get_instr() is called to read the next instruction into MEM.*/
   /*   After the program has been completely loaded, Display_pgm() should be */
   /*   called with pcb->segtable to echo to *.OUT the program just loaded.   */
   /*   Of course, it will use the pcb->segtable to locate each segment.      */
   /*   Use the sample output in intro.doc to determine the format of the     */
   /*   dump and what information should be output.                           */
   /* ----------------------------------------------------------------------- */
   {
      struct instr_type instr, *ptr2instr;
   
      int pgm,
      i, j, k;    /* for incrementation */
      static flag = 0;
   
    /* #ifdef DEBUG3
     if (flag >= 1)
      return;
      #endif */
         #ifdef DEBUG3
      printf("entered Loader\n");
         #endif
   
      ptr2instr = &instr;  /* allocate space */
   
      i = pcb->pgmid;
   
      pgm = pcb->script[i];
         #ifdef DEBUG3
      printf("Loader pgm = %d\n", pgm);
      printf("Loader  Num of segments = %d\n", pcb->segtab_len);
   #endif
   
   
      for(i = 0; i < pcb->segtab_len; i++)          /* load memory */
      {
         #ifdef DEBUG3
         printf("Loader  segment %d length = %d\n", i, pcb->segtable[i].seglen);
      #endif
         for(j = 0; j < pcb->segtable[i].seglen; j++)
         {
         #ifdef DEBUG3
            printf("Loader  get %d instruction \n",(j+1));
         #endif
            Get_Instr(pgm, ptr2instr);
            MEM[j + pcb->segtable[i].membase] = *ptr2instr;
         }  /* End for */
      } /* end first for */
      for(k = 0; k < pcb->segtab_len; k++)
      {
         fprintf(simout, "\n        SEGMENT #%u OF PROGRAM %s OF PROCESS U%03d\n",
                k, pgmidtab[pgm], pcb->termnl + 1);
      
         Display_pgm(&(pcb->segtable[k]), pcb->segtable[k].seglen, *termtable);
      }  /* End of for */
      fprintf(simout, "\n\t   PROGRAM %s HAS BEEN LOADED FOR PROCESS U%03d\n\n",
             pgmidtab[pgm], pcb->termnl+1);
   
   
               #ifdef DEBUG3
      flag++;
      printf("Exit Loader\n\n");
         #endif
   }  /* End Loader */

   void
   Dealloc_pgm(struct pcb_type *pcb)
   /* ----------------------------------------------------------------------- */
   /*   This function frees all allocated segments for the current program.   */
   /*   It then frees the segment table.                                      */
   /*                                                                         */
   /*   (1) Call Dealloc_seg() for each segment in pcb->segtable;             */
   /*   (2) free( pcb->segtable );                                            */
   /* ----------------------------------------------------------------------- */
   {
      int i;  /* for incrementation */
   
      for(i = 0; i < pcb->segtab_len; i++)
         Dealloc_seg(pcb->segtable[i].membase, pcb->segtable[i].seglen);
   
      free(pcb->segtable);
      pcb->segtable = NULL;
      pcb->segtab_len = 0;
   } /* End Dealloc_pgm */


   void
   Dealloc_seg( int base, int len )
   /* ----------------------------------------------------------------------- */
   /*  This function returns a segment at (base) of length (len) to the free  */
   /*  list.  This is a bit tricky.  When returning a segment to the free list*/
   /*  it may cause adjacent free segments to "merge".  If merging takes place*/
   /*  then elements in the free list must be removed.                        */
   /*                                                                         */
   /*  (1) Assuming the elements in the FreeMem list are ordered by base      */
   /*      address, search for the first pair of elements satisfying the      */
   /*      relation:  b[i] < base < b[i+1].  Create a new free list element   */
   /*      with [base, len] and insert it at the appropriate place between    */
   /*      b[i] and b[i+1].                                                   */
   /*                                                                         */
   /*  (2) Call Merge_seg() to scan the FreeMem list looking for adjacent     */
   /*      pairs of elements E[i] = { b[i], len[i] } and                      */
   /*                      E[i+1] = { b[i+1], len[i+1] } where                */
   /*      b[i+1] = b[i]+len[i].  Merge_seg() will "merge" these two elements */
   /*      into one and continue the scan.  Observe that Merge_seg() will find*/
   /*      at most TWO such pairs and they will always be consecutive elements*/
   /*      in the list.                                                       */
   /*                                                                         */
   /* ----------------------------------------------------------------------- */
   {
      struct  seg_list *tracer_cur  = FreeMem,
      *ptracer = NULL,
      *tmp_ptr;
   
      int     foundflag = FALSE;
   
   
      tmp_ptr = (struct seg_list *)calloc(1, sizeof(struct seg_list));
      tmp_ptr->segptr = base;
      tmp_ptr->segsize = len;
      tmp_ptr->next = NULL;
   
   
      if (tracer_cur == NULL)
      {
         FreeMem = tmp_ptr;
         foundflag = TRUE;
      }  /* end if */
   
      if(!foundflag)
      {
         while(tracer_cur !=NULL && tracer_cur->segptr < base)
         {
            ptracer = tracer_cur;
            tracer_cur = tracer_cur->next;
         }  /* End while*/
      
         if(tracer_cur == NULL)
         {
            ptracer->next = tmp_ptr;
            foundflag = TRUE;
         } /* End if */
         else if(ptracer == NULL)
         {
            FreeMem = tmp_ptr;
            tmp_ptr->next = tracer_cur;
            foundflag = TRUE;
         } /* End else if */
         else
         {
            ptracer->next = tmp_ptr;
            tmp_ptr->next = tracer_cur;
         } /* End else */
      } /* End  if(!foundflag) */
   
      TotalFree += len;
   #ifdef DEBUG3
      printf("totalfree = %d in Dealloc_seg-obj3\n", TotalFree);
   #endif
      Merge_seg();
   } /* End Dealloc_seg */


   void
   Merge_seg()
   /* ----------------------------------------------------------------------- */
   /*  This function scans the free list and coelesces contiguous blocks.     */
   /*  The elements on the free list are ordered by the address of the        */
   /*  segment they represent.                                                */
   /*                                                                         */
   /*           Merge_seg() scans the FreeMem list looking for adjacent       */
   /*      pairs of elements E[i] = { b[i], len[i] } and                      */
   /*                      E[i+1] = { b[i+1], len[i+1] } where                */
   /*      b[i+1] = b[i]+len[i].  Merge_seg() will "merge" these two elements */
   /*      into one and continue the scan.  Observe that Merge_seg() will find*/
   /*      at most TWO such pairs and they will always be consecutive elements*/
   /*      in the list.                                                       */
   /* ----------------------------------------------------------------------- */
   {
      struct seg_list *tracer_cur,
      *ltracer;
   
   #ifdef DEBUG3
      printf("entered Merge_seg-obj3\n");
   #endif
   
      tracer_cur = FreeMem;
   
      if(tracer_cur != NULL)            /* at least one node */
         ltracer = FreeMem->next;        /* set ltracer */
   
   
      while(tracer_cur != NULL)
      {
         if((tracer_cur->segptr + tracer_cur->segsize) == ltracer->segptr)
         {
         #ifdef DEBUG3
            printf("merging...obj3\n");
         #endif
         
            tracer_cur->segsize += ltracer->segsize;
            tracer_cur->next = ltracer->next;
            free(ltracer);
            ltracer = tracer_cur->next;
         }  /* End if */
         else
         {
            tracer_cur = tracer_cur->next;
            if(tracer_cur != NULL)
               ltracer = ltracer->next;
         } /* End  else */
      } /* End  While */
   
   #ifdef DEBUG3
      printf("merge exiting!\n");
   #endif
   } /* End Merge_seg() */

   void
   End_Service()
   /* ----------------------------------------------------------------------- */
   /*                 This function services PGMEND events.                   */
   /*                                                                         */
   /*  (1) Let pcb = termtable[AGENT-1].  Mark pcb->status as 'D'ONE.         */
   /*      Set CPU.actvpcb = NULL.                                            */
   /*  (2) If( OBJECTIVE > 3 ) call Purge_rb() to deallocate all IORBs that   */
   /*      are "COMPLETED".                                                   */
   /*  (3) If( pcb->rblist == NULL ) then call Next_pgm( pcb ) to advance the */
   /*         process script and prepare the next program for execution, if   */
   /*         there is one.                                                   */
   /*                                                                         */
   /*  (4) If( OBJECTIVE > 3 ) SCHED_SW = CPU_SW = 1;                         */
   /*                                                                         */
   /* ----------------------------------------------------------------------- */
   {
      struct pcb_type   *mypcb;
		struct simtime    rtime,ttime, difft,  /* temp vars for difference in time */
		 tclock; /* temp var to capture CLOCK time */
      unsigned long     tnano, /* temp var for total nanosec */
      I; /* temp var for intructions */
   #ifdef DEBUG3
      printf("entered End_service\n");
      Dev_rblist();
   #endif
   
   
      mypcb = termtable[AGENT - 1];
      mypcb->status = 'D';
   
		tclock = difft = ttime = rtime = CLOCK;

   #ifdef DEBUG3
      printf("!!!!tclock.sec = %u  tclock.nano = %u\n",
            tclock.seconds,tclock.nanosec);
   #endif
		Diff_time(&mypcb->runt, &difft);
		Add_time(&difft, &mypcb->trun);
   #ifdef DEBUG3
      printf("!!!!difft.sec = %u  difft.nano = %u\n",
            difft.seconds,difft.nanosec);
   #endif
      tnano = difft.nanosec + (difft.seconds * SEC);
   #ifdef DEBUG3
      printf("!!!!tnano = %u  CPU.rate = %u\n",tnano, CPU.rate);
   #endif
      I = tnano / CPU.rate;
   #ifdef DEBUG3
      printf("!!!!I = %d\n",I);
   #endif
		Diff_time(&mypcb->logont,&ttime);
      mypcb->tlogon = ttime;
   #ifdef DEBUG3
      printf("!!!!total logon.sec = %u  nano = %u\n",mypcb->tlogon.seconds,
            mypcb->tlogon.nanosec);
   #endif
   
      sprintf(mypcb->user, "U%3.3d", AGENT);
      fprintf(simout, "\n\t  END OF PROGRAM %s FOR PROCESS U%03d\n",
             pgmidtab[mypcb->script[mypcb->pgmid]], AGENT);
      fprintf(simout, "\n\t  CPU BURST WAS %d INSTRUCTIONS.\n", I);
      CPU.actvpcb = NULL;
   #ifdef DEBUG3
      Dev_rblist();
   #endif
      if(OBJECTIVE > 3)
         Purge_rb(mypcb);
   #ifdef DEBUG3
      Dev_rblist();
	#endif
		rtime = mypcb->tlogon;
		Diff_time(&mypcb->trun, &rtime);
		Diff_time(&mypcb->tblocked, &rtime);
		mypcb->tready = rtime;

		if(mypcb->firstrb == NULL)
         Next_pgm(mypcb);
   
      if(OBJECTIVE > 3)
         SCHED_SW = CPU_SW = 1;
   #ifdef DEBUG3
      Dev_rblist();
      printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
      printf("Exit End_service\n\n");
   #endif
   
   }  /* End End_Service() */


   void
   Abend_Service()
   /* ----------------------------------------------------------------------- */
   /*     This function services SEGFAULT and ADRFAULT events.                */
   /*                                                                         */
   /*     (1) Print a banner message to *.OUT that PROCESS Uxxx has terminated*/
   /*         due to a SEGMENT FAULT or an ADDRESS FAULT (which ever is speci-*/
   /*         fied by EVENT). "Uxxx" is given by termtable[AGENT-1]->user.    */
   /*                                                                         */
   /*     (2) Call End_Service();                                             */
   /* ----------------------------------------------------------------------- */
   {
   #ifdef DEBUG3
      printf("entered Abend_Service\n");
   #endif
   
      fprintf(simout, "   PROCESS %4s TERMINATION CAUSED BY %s\n",
             termtable[AGENT - 1]->user, eventidtab[EVENT]);
   
      End_Service();
   } /* End Abend_Service */


/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
   End   OBJECTIVE 3
****************************************************************************/
