/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600

   Simulator Project    Original Design:  Dr. David Workman
   Revised  Tim Hughey  Mark Stephens

	OBJECTIVE 4

   obj4.c - Version 1.1    - created April 14, 1999
					  - last updated April 28, 1999

****************************************************************************/
/***************************************************************************
							my index of obj 4 funtions
void
Add_cpuq( struct pcb_type *pcb )

struct pcb_type *
Scheduler(void)

void
Sio_Service(void)

void
Start_IO(int dev)

void
Add_devq(int dev, struct rb_type *rb)

void
Add_rblist( struct pcb_type *pcb, struct rb_type *rb)

void
Wio_Service(void)

struct rb_type *
Find_rb( struct pcb_type   *pcb, struct addr_type  *reqid)

void
Delete_rb( struct rb_type   *rb, struct pcb_type *pcb )

void
Eio_Service(void)

void
Purge_rb( struct pcb_type *pcb )

void
Dispatcher(void)

void
LoadMap(struct segment_type *segtab, int numseg )
****************************************************************************/
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"
/*
#define DEBUG4
*/

#define     MAXOP    6     /* max number of opcodes - for 'for-looping' */
#define ZERO   0
#define TRUE   1
#define FALSE  0

#ifdef DEBUG4
   FILE *dbg4_fp;		/* my debug file pointer */
#endif

/********************** Objective 4 functions *******************************/

void
Pcb_status(void)
   /* ------------------------------------------------------------------------- */
   /*      This function prints the termtable pcbs status for debugging         */
   /* ------------------------------------------------------------------------- */
   {
	int i;
      #ifdef DEBUG4
	printf("\n");
      for (i = 0; i < TRMSIZE; i++)
      {
	printf("PCB[%d]: user %s: status is %c\n",i, termtable[i]->user,
	termtable[i]->status);
      }
	printf("\n");
      #endif
   } /* end Pcb_status */

   void
   Pcb_rblist( struct pcb_type *pcb)
   /* ------------------------------------------------------------------------- */
   /* This function prints RB-list of (pcb)     */
   /* ------------------------------------------------------------------------- */
   {
   struct rb_list 	*tracer;
   struct rb_type	*wait;
int i = 0;
   #ifdef DEBUG4
	tracer = pcb->firstrb;
	wait = pcb->wait;
	printf("\n>>>>>>>>>>>PCB - rblist\n");
	if (wait != NULL)
	{
		 printf("PCB-wait status=%c: dev:%d: pcb[%d]\n",
		wait->status, wait->dev, wait->pcb->termnl );
	}
	else
	    printf("PCB-wait rb waiting is NULL\n");
	if (tracer == NULL)
	{
	printf("\nPCB-rblist is empty\n");
	}
	printf("\n");
	while (tracer != NULL)
	{
	i++;
	printf("%d - rb status=%c:  dev:%d: pcb[%d]\n",
	i,tracer->rb->status, tracer->rb->dev, tracer->rb->pcb->termnl );
	tracer = tracer->next;
	}
	printf("\n");
      #endif

   } /* end Pcb_rblist */


   void
   Dev_rblist(void)
   /* ------------------------------------------------------------------------- */
   /* This function prints RB-list of devtable devices    */
   /* ------------------------------------------------------------------------- */
   {
   struct rb_list *tracer;
int i, j = 0;
   #ifdef DEBUG4
	printf("\n<<<<<<<<<<<DEV - rblist\n");
      for (i = 0; i < DEVSIZE; i++)
      {
	tracer = devtable[i].head;
      if (devtable[i].currb != NULL)
	{
	printf("DEV[%d]: currb.status=%c: dev=%d:  PCB[%d]\n",i, devtable[i].currb->status,
	devtable[i].currb->dev, devtable[i].currb->pcb->termnl);
	}
      else
	{
	printf("DEV[%d]: currb is NULL\n",i);
	}
	if (tracer == NULL)
	{
	printf("DEV-rblist is empty\n");
	}
	j=0;
	while (tracer != NULL)
	{
	j++;
	printf("%d - rb status=%c:  dev:%d: pcb[%d]\n",
	j,tracer->rb->status, tracer->rb->dev, tracer->rb->pcb->termnl );
	tracer = tracer->next;
	}
	printf("\n");
      } /* end for */
      #endif

   } /* end Dev_rblist */

   void
   Add_cpuq( struct pcb_type *pcb )
   /* ------------------------------------------------------------------------- */
   /*      This function adds an element to the CPU ready queue for (pcb)       */
   /* ------------------------------------------------------------------------- */
   {

		int   stopflag,
				i;

		struct pcb_list *ptr2listnode, *tracer, *prevnode;

		static flag = FALSE;

				#ifdef DEBUG4
				/*
		if( (dbg4_fp=fopen("DEBUG/dbg_4.dat","a"))==NULL)
		{
			printf("dbg_4.dat file does not exist! \n");
			exit(0);
		}
		*/
	#endif
	#ifdef DEBUG4
		printf("entered Add_cpuq\n");
	#endif

		flag++;
	#ifdef DEBUG4
		printf("Add_cpuq flag=%d -obj4\n\n", flag);
	#endif

		if ((ptr2listnode =
			(struct pcb_list*) malloc(sizeof(struct pcb_list))) == NULL)
		{
			printf("Not enough memory to allocate pcb_list node\n");
			exit(1);
		}    /* end if */

		ptr2listnode->pcb = pcb;      /* fill new node */
		ptr2listnode->prev = NULL;
		ptr2listnode->next = NULL;

		if (CPU.ready == NULL)
		{                             /* if list is empty, make head of list */
			CPU.ready = ptr2listnode;
			CPU.tail = ptr2listnode;
      }

      else 
		{                             /* else 1 or more nodes in list */
			tracer = CPU.tail;      /* set tracer ptr to tail */
			ptr2listnode->prev = tracer;  /* insert node at end */
			tracer->next = ptr2listnode;
			CPU.tail = ptr2listnode;
		} /* end else 1 or more nodes */

		#ifdef DEBUG4
		printf("inside Add_cpuq: node %d user=%s -obj4\n",
			CPU.qlen, CPU.tail->pcb->user );
	#endif

	} /* end Add_cpuq */


	struct pcb_type *
	Scheduler(void)
	/* ------------------------------------------------------------------------- */
   /*      This function selects the next process for allocation to the CPU     */
   /*      according to the currently active scheduling algorithm.              */
   /*                                                                           */
   /*      (1) FCFS: Remove the first queue entry, deallocate the queue         */
   /*                element and return the pcb pointer from the element        */
   /*                                                                           */
   /*      (2) HPRN: Compute the penalty ratio for each pcb in the queue. As    */
   /*                you do this, keep a pointer to the queue element having    */
   /*                the smallest ratio so far.  NOTE: if you start at the      */
   /*                front of the queue, this algorithm automatically selects   */
   /*                the correct pcb in case of a tie.                          */
   /*                                                                           */
   /*                P  = (queue wait time)/( estimated service time )          */
   /*                                                                           */
   /*                S' = (estimated service time)                              */
   /*                   = (1-RHO)*sjnave + RHO*sjnburst                         */
   /*                                                                           */
   /*                NOTE: P is set to ONEOVRBETA if the program has never had  */
   /*                      service.  You can use pcb->flag to indicate whether  */
   /*                      or not a program has had service.                    */
   /*                                                                           */
   /*                NOTE: sjnave is updated to S' for the process selected by  */
   /*                      the scheduler.                                       */
   /*                                                                           */
   /*                NOTE: sjnburst is the length of the last CPU burst and is  */
   /*                      measured by the length of time between successive    */
   /*                      events of the following kinds:  program start, block */
   /*                      for I/O, program end.                                */
   /* ------------------------------------------------------------------------- */
	{
	  struct pcb_list *list_tracer;
	  struct pcb_type *pcb_tracer;
	  struct simtime  difft;


   #ifdef DEBUG4
		printf("entered Scheduler\n");
		Pcb_status();
		Dev_rblist();
	#endif

      if (CPU.ready == NULL)
	 {
   #ifdef DEBUG4
      printf("\n Scheduler- nothing in queue - CPU.ready == NULL -obj4 \n");
	#endif
	return NULL;
	 }

	if (SCHED == FCFS)
	{
		difft = CLOCK;

		if (CPU.ready == CPU.tail)  /* only one node */
		{
		pcb_tracer = CPU.ready->pcb;
   #ifdef DEBUG4
      printf("Set PCB[%d]: user %s: status is %c  active\n", pcb_tracer->termnl,
		pcb_tracer->user, pcb_tracer->status);
	#endif
		list_tracer = CPU.ready;
		list_tracer->pcb = NULL;
		CPU.ready = NULL;
		CPU.tail = NULL;
		free(list_tracer);     /* deallocate list node */
		CPU.served++;
		}
		else         /* more than 1 node */
		{
		pcb_tracer = CPU.ready->pcb;
		list_tracer = CPU.ready;
		list_tracer->pcb = NULL;
		CPU.ready = list_tracer->next;  /* advance the list */
		free(list_tracer);     /* deallocate list node */
		CPU.served++;
		}
	} /* end if FCFS */
	else if (SCHED == HPRN) /* HPRN */
	{
		printf("HPRN algorithm to be completed at a later time\n");
		exit(0);
	}  /* end else */
	/********** get time stats ************/
		pcb_tracer->status = 'A';
		pcb_tracer->runt = CLOCK;
		Diff_time(&pcb_tracer->readyt, &difft);
		Add_time(&difft, &pcb_tracer->waitq);
		return pcb_tracer;                   /* return the pointer to the PCB */

		#ifdef DEBUG4
		printf("finished Scheduler -obj4\n\n");
	#endif
   } /* end Scheduler */


   void
   Sio_Service(void)
   /* ------------------------------------------------------------------------- */
   /*   This function services requests to start an I/O operation.              */
	/*                                                                           */
   /*   (1) Allocate an I/O request block (rb).                                 */
	/*   (2) Set rb->status to "PENDING"                                         */
	/*   (3) Set rb->pcb    to termtable[AGENT-1]                                */
	/*   (4) Set rb->dev    to devtable index of requested device.  This one     */
	/*                      is tricky.  You must use the value of the program    */
	/*                      counter in rb->pcb->cpu_save.pc to located the      */
	/*                      device instruction identifying the requested         */
	/*                      device.                                              */
	/*   (5) Set rb->queuet to the value of CLOCK.                               */
	/*   (6) Set rb->bytes  to the operand field of the device instruction       */
	/*                      located in (4).                                      */
	/*   (7) Set rb->reqid  to the logical address of the device instruction     */
	/*                      located in (4).                                      */
	/*   (8) Now queue up (rb) on the requested device wait list by calling      */
	/*       Add_devq(device,rb);                                                */
	/*   (9) Add the (rb) to the list of IORBs owned by the requesting process.  */
	/*       Call Add_rblist(pcb,rb);                                            */
	/*  (10) Attempt to initiate an operation on the requested device by calling */
	/*       StartIO( rb->dev );                                                 */
	/*  (11) Return control to the interrupted process by setting CPU_SW = 1     */
	/*        and SCHED_SW = 0;                                                  */
	/* ------------------------------------------------------------------------- */
	{
		struct 	rb_type *ptr2rb;
		struct 	rb_list *ptr2rblistnode;
		int      memidx,
					segtabidx;

         
	#ifdef DEBUG4
		printf("entered Sio_Service\n");
	#endif
	  /*****  1  *****/
		if ((ptr2rb = (struct rb_type*) malloc(sizeof(struct rb_type))) == NULL)
		{
			printf("Not enough memory to allocate rb_type node\n");
			exit(1);
		}    /* end if */
	  /*****  2  *****/
		ptr2rb->status = 'P';
	  /*****  3  *****/
		ptr2rb->pcb = termtable[AGENT-1];
	  /*****  4  *****/
		segtabidx = ptr2rb->pcb->cpu_save.pc.segment;
		memidx = (ptr2rb->pcb->segtable[segtabidx].membase
					+ (ptr2rb->pcb->cpu_save.pc.offset - 1));
		ptr2rb->dev  = (MEM[memidx].opcode - MAXOP);/* ptr2rb->pcb->cpu_state.pc; */
	#ifdef DEBUG4
		printf("\nSio_Service - dev id is %d\n\n", ptr2rb->dev);
	#endif
	  /*****  5  *****/
		ptr2rb->queuet = CLOCK;
	  /*****  6  *****/
		ptr2rb->bytes = MEM[memidx].operand.bytes;
	  /*****  7  *****/
		ptr2rb->reqid.segment = ptr2rb->pcb->cpu_save.pc.segment;
		ptr2rb->reqid.offset = ptr2rb->pcb->cpu_save.pc.offset - 1;
	  /*****  8  *****/
		Add_devq(ptr2rb->dev, ptr2rb);
			#ifdef DEBUG4
		Dev_rblist();
			#endif
	  /*****  9  *****/
		Add_rblist(ptr2rb->pcb, ptr2rb);
	#ifdef DEBUG4
		Pcb_rblist(ptr2rb->pcb);
		Dev_rblist();
	#endif

	  /*****  10  *****/
		Start_IO(ptr2rb->dev);
     /*****  11  *****/
		CPU_SW = 1;
		SCHED_SW = 0;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif

	#ifdef DEBUG4
		printf("finished Sio_Service\n\n");
	#endif
	} /* end Sio_Service */


   void
	Start_IO(int dev)
	/* ------------------------------------------------------------------------- */
	/*       This function attempts to start an operation on device (dev).       */
	/*                                                                           */
	/*   (1) Check to see if the device is busy: devtable[dev].currb != NULL     */
	/*       If so, just return.                                                 */
	/*                                                                           */
	/*   (2) Check to see if the device queue is empty.  If so, just return.     */
	/*                                                                           */
	/*   (3) Remove the next rb from the device queue and store it in currb.     */
	/*       Mark the status of the IORB (*currb) as ACTIVE.                     */
	/*       Deallocate the queue element. (NOT the rb you just removed!)        */
	/*                                                                           */
	/*   (4) Using the rb->bytes and the speed of the device, compute the        */
	/*       (eiotime) at which the operation will terminate.  This can be       */
	/*       done by using the same computation you used in Cpu() for            */
	/*       computing event times.                                              */
	/*                                                                           */
	/*   (5) Add_event(&eiotime, EIO, dev+TRMSIZE+1)                             */
	/* ------------------------------------------------------------------------- */
	{

	struct rb_list *ptr2listnode;

	struct simtime 	difft, tclock, /* temp variables to capture current clock*/
							eiotime;  /* for bytes transfer time */
	 unsigned long    tsec = 0;  /* total seconds */
	int 	memidx;

	#ifdef DEBUG4
		printf("entered Start_IO\n");
		Dev_rblist();
	#endif
	/**********   1   **********/
	if (devtable[dev].currb != NULL)
	{
		return;
	} /* end if device is busy */

	/**********   2   **********/
	if (devtable[dev].head == NULL)
	{
		return;
	} /* end if device list is empty */


	/**********   3   **********/
	#ifdef DEBUG4
		printf("About to set currb to head and delete head\n");
	#endif
	fprintf(simout, "\n         START IO ON device %s\n", devtable[dev].devid);
	devtable[dev].currb = devtable[dev].head->rb;
	devtable[dev].currb->status = 'A';
	ptr2listnode = devtable[dev].head;
	devtable[dev].head = devtable[dev].head->next;

	/**********   get dev wait time   **********/
	difft = CLOCK;
	Diff_time(&devtable[dev].currb->queuet, &difft);
	Add_time(&difft, &devtable[dev].qwait);
   devtable[dev].currb->queuet = CLOCK;


	if (devtable[dev].head == NULL)
	{
	 devtable[dev].tail = NULL;
	}
	free(ptr2listnode);
	devtable[dev].served++;
	#ifdef DEBUG4
   	Dev_rblist();
		printf("Start_IO set currb and delete listnode -obj4\n");
		printf("***bytes=%u: CLOCK.S=%u  CLOCK.N=%u********\n",
		devtable[dev].currb->bytes, CLOCK.seconds, CLOCK.nanosec);
	#endif
	/**********   4   **********/
	/* capture clock time */
	tclock = CLOCK;
	/* using bytes and dev rate - get time in sec for bytes to transfer */
	tsec = (devtable[dev].currb->bytes / devtable[dev].byps);
	eiotime.seconds = tsec;
	eiotime.nanosec = ((devtable[dev].currb->bytes -
				(devtable[dev].byps * eiotime.seconds)) * devtable[dev].npb);
	#ifdef DEBUG4
	printf("before@ eio.sec=%u:  eio.nano=%u\n",eiotime.seconds,eiotime.nanosec);
	#endif
	 Add_time(&tclock, &eiotime);
	#ifdef DEBUG4
	printf("afteradding CLOCK@ eio.sec=%u:  eio.nano=%u\n",eiotime.seconds,eiotime.nanosec);
	#endif

		#ifdef DEBUG4
		printf("***bytes=%u: CLOCK.S=%u  CLOCK.N=%u********\n",
		devtable[dev].currb->bytes, tclock.seconds, tclock.nanosec);
	printf("***final*****eio.sec=%u:  eio.nano=%u\n",eiotime.seconds,eiotime.nanosec);
		printf("********byps=%u:  npb=%u\n",devtable[dev].byps,devtable[dev].npb);
		printf("  eio.sec=%u eio.nano=%u -obj4\n", eiotime.seconds,
					eiotime.nanosec);
	#endif

	/**********   5   **********/
	Add_event(&eiotime, EIO, (dev+TRMSIZE+1));
		#ifdef DEBUG4
		printf("  pcb[%d] dev[%d] -obj4\n", devtable[dev].currb->pcb->termnl,
					dev);
	#endif

	 devtable[dev].qlen--;



	#ifdef DEBUG4
		printf("Exit Start_IO\n\n");
	#endif
   
   } /* end Start_IO */ 


   void
   Add_devq(int dev, struct rb_type *rb)
   /* ------------------------------------------------------------------------- */
   /* This function adds an entry (RB pointer (rb)) to the wait queue of device */
   /* (dev).                                                                    */
   /* ------------------------------------------------------------------------- */
	{

		int   stopflag,
				i;

		struct rb_list *ptr2listnode, *tracer;

		static flag = FALSE;
	#ifdef DEBUG4
		printf("entered Add_devq\n");
	#endif

		flag++;
	#ifdef DEBUG4
		printf("Add_devq flag=%d -obj4\n\n", flag);
	#endif


		if ((ptr2listnode =
			(struct rb_list*) malloc(sizeof(struct rb_list))) == NULL)
		{
			printf("Not enough memory to allocate rb_list node\n");
			exit(1);
		}    /* end if */

		ptr2listnode->rb = rb;      /* fill new node */
		ptr2listnode->next = NULL;

		if (devtable[dev].head == NULL)
		{                             /* if list is empty, make head of list */
			devtable[dev].head = ptr2listnode;
			devtable[dev].tail = ptr2listnode;
		      }

      else
		{                             /* else 1 or more nodes in list */
			tracer = devtable[dev].tail;      /* set tracer ptr to tail */
			tracer->next = ptr2listnode;        /* insert node at end */
			devtable[dev].tail = ptr2listnode;
		} /* end else 1 or more nodes */

	#ifdef DEBUG4
		printf("Exit Add_devq\n\n");
	#endif

   } /* end Add_devq */


   void
   Add_rblist( struct pcb_type *pcb, struct rb_type *rb)
   /* ------------------------------------------------------------------------- */
   /* This function adds an entry (RB pointer (rb)) to the RB-list of (pcb)     */
   /* ------------------------------------------------------------------------- */
   {
   
		int   stopflag,
				i;

		struct rb_list  *ptr2listnode, *tracer;

		static flag = FALSE;
   #ifdef DEBUG4
		printf("entered Add_rblist\n");
	#endif

		flag++;
	#ifdef DEBUG4
		printf("Add_rblist flag=%d -obj4\n\n", flag);
	#endif


	if ((ptr2listnode =
			(struct rb_list*) malloc(sizeof(struct rb_list))) == NULL)
		{
			printf("Not enough memory to allocate rb_list node\n");
			exit(1);
		}    /* end if */

		ptr2listnode->rb = rb;      /* fill new node */
		ptr2listnode->next = NULL;

	#ifdef DEBUG4
		printf("\nadding RB seg = %d; off = %d -obj4\n",
		ptr2listnode->rb->reqid.segment, ptr2listnode->rb->reqid.offset);
	#endif
		if (pcb->firstrb == NULL)
		{                             /* if list is empty, make head of list */
			pcb->firstrb =  ptr2listnode;
			pcb->lastrb =  ptr2listnode;
		}

      		else 
		{                             /* else 1 or more nodes in list  */
			tracer = pcb->lastrb;
			tracer->next = ptr2listnode;  
			pcb->lastrb = ptr2listnode;  
		} /* end else 1 or more nodes */

	#ifdef DEBUG4
		printf("Exit Add_rblist\n\n");
	#endif

   } /* end Add_rblist */


   void
   Wio_Service(void)
   /* ------------------------------------------------------------------------- */
   /*      This function services requests to check an I/O operation            */
   /*      for completion.  If the operation is complete, the process           */
   /*      resumes execution immediately; otherwise, the process is blocked.    */
   /*                                                                           */
   /*  Let pcb = termtable[AGENT-1]                                             */
   /*                                                                           */
   /*  (1) Using pcb->cpu_save.pc locate the REQ instruction and retrieve the   */
   /*      address field (reqid).                                               */
   /*                                                                           */
   /*  (2) Call Find_rb using reqid to locate the IORB that defines the oper-   */
   /*      ation the process wants to wait for.                                 */
   /*                                                                           */
   /*  (3) Check the status of the IORB, if it is PENDING or ACTIVE then the    */
   /*      process must be blocked.  If this is the case, then mark pcb->status */
   /*      as BLOCKED and save the IORB pointer in pcb->waitrb.                 */
   /*      Set CPU.actvpcb to NULL, CPU_SW = SCHED_SW = 1, and return.          */
   /*                                                                           */
   /*  (4) If the IORB is COMPLETE, then the process may continue running. In   */
   /*      this case call Delete_rb() to deallocate the IORB, remove and de-    */
   /*      allocate the rblist element holding its pointer.  Then set CPU_SW=1  */
   /*      and SCHED_SW = 0 and return.                                         */
   /* ------------------------------------------------------------------------- */
   {
	#define 	active  'A'
	#define		pending 'P'
	#define		done  	'D'

	struct addr_type 	my_reqid;
   	struct rb_type 		*wiorb;
	struct pcb_type		*wio_pcb;
		struct simtime    ttime, difft,  /* temp vars for difference in time */
								tclock; /* temp var to capture CLOCK time */
		unsigned long 		tnano, /* temp var for total nanosec */
								I;	/* temp var for intructions */
	int      		memidx,
				segtabidx;
	char 			status;

	#ifdef DEBUG4
		printf("entered Wio_Service\n");
	#endif
   

	wio_pcb = termtable[AGENT-1];


	/**********   1   **********/
	segtabidx = wio_pcb->cpu_save.pc.segment;
	memidx = (wio_pcb->segtable[segtabidx].membase
		+ (wio_pcb->cpu_save.pc.offset - 1));
	my_reqid = MEM[memidx].operand.address;

	#ifdef DEBUG4
		printf("Wio_Service - my_reqid.seg = %d; my_reqid.off = %d -obj4\n",
			my_reqid.segment, my_reqid.offset);
	#endif
	
	/**********   2   **********/
	wiorb = Find_rb(wio_pcb, &my_reqid);
	#ifdef DEBUG4
		printf("Wio_Service - finished find_rb\n");
		printf("Wio_Service - this termtable pcb = %d \n", (AGENT-1));
	#endif
	/**********   3   **********/
	status = wiorb->status;
	switch(status)
	{
		case active:
		case pending:
	#ifdef DEBUG4
		printf("Wio_Service - active or pending\n");
	#endif
			wio_pcb->status = 'B';
			fprintf(simout, "\n         PROCESS %s IS BLOCKED FOR I/O.",
						wio_pcb->user);
			wio_pcb->wait = wiorb;
	#ifdef DEBUG4
printf("put rb on wait: PCB-wait status=%c: dev:%d: pcb[%d]\n",
		wio_pcb->wait->status, wio_pcb->wait->dev, wio_pcb->wait->pcb->termnl );
      Pcb_rblist(wio_pcb);
	#endif
			CPU.actvpcb = NULL;
			CPU_SW = SCHED_SW = 1;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			/************ get time stats **********/

			wio_pcb->blockedt = difft = ttime = tclock = CLOCK;

			Diff_time(&wio_pcb->readyt, &ttime);


			Diff_time(&wio_pcb->runt,&difft);
		  	Add_time(&difft, &wio_pcb->trun);

	tnano = difft.nanosec + (difft.seconds * SEC);
	#ifdef DEBUG3
	printf("!!!!tnano = %u  CPU.rate = %u\n",tnano, CPU.rate);
	#endif
		I = tnano / CPU.rate;
	#ifdef DEBUG3
	printf("!!!!I = %d\n",I);
	#endif

	#ifdef DEBUG4
	printf("!!!!!!!!trun.sec = %d;  trun.nano = %d !!!!!!!\n",
			wio_pcb->trun.seconds,  wio_pcb->trun.nanosec);
	#endif
fprintf(simout, "\n         CPU BURST WAS %u INSTRUCTIONS.\n", I);
			return;
	/**********   4   **********/
		case done:
			/********** get time stats ************/
			Diff_time(&wio_pcb->readyt, &ttime);

			Delete_rb(wiorb, wio_pcb);
			CPU_SW = 1; 
			SCHED_SW = 0;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			return;
		default:
			printf("Error - wrong IORB status");
			exit(0);
	} /* end switch status */


   
   #ifdef DEBUG4
		printf("Exit Wio_Service\n\n");
	#endif
   } /* end Wio_Service */ 


   struct rb_type *
   Find_rb( struct pcb_type *pcb, struct addr_type  *reqid)
   /* ------------------------------------------------------------------------- */
   /* This function searches the RB list of (pcb) to locate the RB identified   */
   /* by (reqid).  The pointer to the RB selected is returned.                  */
   /* ------------------------------------------------------------------------- */
   {
   	struct rb_list *tracer;
	int foundflag = FALSE,
		seg;
	unsigned int	off;
	struct rb_type *ptr2rb;

	#ifdef DEBUG4
		printf("entered Find_rb\n");
	#endif
	seg = reqid->segment;
	off = reqid->offset;

	#ifdef DEBUG4
		printf("Find_rb - looking for seg = %d & offs = %u -obj4\n", seg, off);
	#endif

	tracer = pcb->firstrb;
	while ((foundflag == FALSE) && (tracer != NULL))
	{
		if ((tracer->rb->reqid.segment == seg) && (tracer->rb->reqid.offset == off))
		{
			foundflag = TRUE;
			ptr2rb = tracer->rb;

	#ifdef DEBUG4
		printf("Found rb -obj4\n");
	#endif
		}
		else
		{
	#ifdef DEBUG4
		printf("still looking for rb -obj4\n");
	#endif
			tracer= tracer->next;
		}
	} /* end while not found */

	if (foundflag)
		return ptr2rb;
	else		
	{
		printf("Problem in Find_rb - couldn't find rb!!\n");
		return;
	}	
		
   
   #ifdef DEBUG4
		printf("Exit Find_rb\n\n");
	#endif

   } /* end Find_rb */ 


   void
   Delete_rb( struct rb_type *rb, struct pcb_type *pcb )
   /* ------------------------------------------------------------------------- */
   /*    This function deletes the entry in the RB-list of (pcb) containing     */
   /*    (rb), if there is one.  It also deallocates the rb if it is found.     */
   /* ------------------------------------------------------------------------- */
	{
	struct rb_list *ptr2listnode, *tracer, *prev;
	int foundflag = FALSE,
		i = 0;

	#ifdef DEBUG4
		printf("entered Delete_rb\n");
			Pcb_rblist(pcb);
	#endif


	tracer = pcb->firstrb;
	prev = NULL;

	while ((tracer != NULL) && (foundflag == FALSE))
	{
	  if (tracer->rb == rb)
	  {
		  if(tracer == pcb->firstrb) /* if 1st node */
		  {
		if (pcb->firstrb == pcb->lastrb) /* only one node */
		{
		i++;
			foundflag = TRUE;
		  pcb->firstrb = NULL;
		  pcb->lastrb = NULL;
		  free(tracer);
	#ifdef DEBUG4
			Pcb_rblist(pcb);
		printf("only one node in list -deleted %d rb\n", i);
	#endif
		} /* end only one node */
		else
		{
		i++;
			foundflag = TRUE;
		  pcb->firstrb = pcb->firstrb->next;
		  free(tracer);
	#ifdef DEBUG4
			Pcb_rblist(pcb);
		printf("more than one in list - deleted 1st %d rb\n", i);
	#endif
		}
		tracer = pcb->firstrb;
		  } /* end if 1st node */
		  else /* not 1st node */
		  {
		if (tracer == pcb->lastrb) /* if last node */
		{
		i++;
			foundflag = TRUE;
		  pcb->lastrb = prev;
		  pcb->lastrb->next = NULL;
		  free(tracer);
	#ifdef DEBUG4
			Pcb_rblist(pcb);
		printf("node was tail - deleted %d rb\n", i);
	#endif
		}
		else
		{
			i++;
         foundflag = TRUE;
			prev->next = tracer->next;
			free(tracer);
	#ifdef DEBUG4
				Pcb_rblist(pcb);
		printf("middle node - deleted %d rb\n", i);
	#endif
		}/* end middle child */
		  } /* end else not 1st node */
		/*  free(tracer->rb); */
	  } /* end if equal to rb */
	  else
	  {
		 prev = tracer;
		 tracer = tracer->next;
	  } /* end else not equal to 'D' */

	} /* end while tracer != NULL */


	#ifdef DEBUG4
		printf("Exit Delete_rb\n\n");
	#endif

	} /* end Delete_rb */

	void
	Eio_Service(void)
	/* ------------------------------------------------------------------------- */
	/*           This function services interrupts from I/O devices.             */
	/*                                                                           */
	/*  Let device be &devtable[AGENT-TRMSIZE-1].  Let pcb = device->currb->pcb. */
	/*  Let rb = device->currb and set device->currb to NULL!                    */
	/*  (1) Mark rb->status as COMPLETE.                                         */
	/*  (2) Call StartIO() to initiate another operation on dev= AENT-TRMSIZE-1. */
	/*  (3) switch(pcb->status){                                                 */
	/*      case 'R': case 'A':  the interrupted process, if any, can resume.    */
	/*                            CPU_SW = SCHED_SW = 0;break;                   */
	/*        case 'B': check to see if process is waiting for the operation     */
	/*                  that just completed.                                     */
	/*                  compare rb with pcb->waitrb.  If they match, then call   */
	/*                  Delete_rb(rb,pcb).  Set pcb->waitrb to NULL and pcb->    */
	/*                  status to 'R'.  And Add_cpuq(pcb).                       */
	/*                  if(CPU.actvpcb == NULL ) Set CPU_SW = SCHED_SW = 1;      */
	/*                  else  CPU is busy    Set CPU_SW = SCHED_SW = 0;          */
	/*                  break;                                                   */
	/*      case 'D':  the process is done, but waiting for I/O to complete.     */
	/*                 So,                                                       */
	/*                 Call Delete_rb(rb,pcb) to remove the completed IORB       */
	/*                 from the rbwait list of pcb.  Now call Next_pgm() to      */
	/*                 try to load the next program for pcb.  If Next_pgm        */
	/*                 succeeds, mark pcb->status as 'R' and                     */
	/*                 if(CPU.actvpcb == NULL ) Set CPU_SW = SCHED_SW = 1;       */
	/*                 else  CPU is busy    Set CPU_SW = SCHED_SW = 0;           */
	/*                 break;                                                    */
	/*        default:  pcb->status = 'T' should be impossible!                  */
	/*      }                                                                    */
	/* ------------------------------------------------------------------------- */
	{
	 struct device_type 	*eiodev = &devtable[(AGENT-TRMSIZE-1)];
	 struct pcb_type 	*eiopcb  = eiodev->currb->pcb;
	 struct rb_type 	*eiorb = eiodev->currb;
	 struct simtime 	difft, ttime, tclock;
	 int dev,
		success;

	#ifdef DEBUG4
		printf("entered Eio_Service\n");
		printf("Eio_dev =  %d\n", (AGENT-TRMSIZE-1));
		printf("cur pcb =  %d\n", (eiodev->currb->pcb->termnl));
		printf("eiorb.dev =  %d\n", (eiorb->dev));
		printf("Set currb to NULL & status 'D'\n");
		Dev_rblist();
	#endif
	difft = tclock = CLOCK;
	eiodev->currb = NULL;

	/*********   1  *********/
	eiorb->status = 'D';

	/*********   get device time  *********/
	 Diff_time(&eiorb->queuet, &difft);
    Add_time(&difft, &devtable[eiorb->dev].busy);

	/*********   2  *********/
	Start_IO(AGENT-TRMSIZE-1);
	/*********   3  *********/
	difft = tclock = CLOCK;
	switch(eiopcb->status)
	{
		case 'R':
		case 'A':
			CPU_SW = SCHED_SW = 0;
	#ifdef DEBUG4
	printf("pcb.status = %c\nSCHED_SW = %d;  CPU_SW = %d \n",
		eiopcb->status,SCHED_SW,CPU_SW);
	#endif
			break;
		case 'B':
	#ifdef DEBUG4
	printf("in BLOCKED status\n");
	#endif
			if (eiorb == eiopcb->wait)
			{
	#ifdef DEBUG4
	printf("Rb->wait == to currb\n");
	#endif
			Delete_rb(eiorb, eiopcb);
			eiopcb->wait == NULL;
			eiopcb->status = 'R';
         eiopcb->readyt = tclock;
			Diff_time(&eiopcb->blockedt, &difft);
         Add_time(&difft, &eiopcb->tblocked);
			Add_cpuq(eiopcb);
			}
			if(CPU.actvpcb == NULL)
			{
			 CPU_SW = SCHED_SW = 1;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			}
			else
			{
			  CPU_SW = SCHED_SW = 0;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			}
			break;

		case 'D':
			Delete_rb(eiorb,eiopcb);
			success = Next_pgm(eiopcb);
			if (success == 1)
			{
			  eiopcb->status == 'R';
			 eiopcb->readyt = tclock;
			Diff_time(&eiopcb->blockedt, &difft);
         Add_time(&difft, &eiopcb->tblocked);
			}
			  if(CPU.actvpcb == NULL)
			  {
			   CPU_SW = SCHED_SW = 1;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			   }
			   else
			   {
			     CPU_SW = SCHED_SW = 0;
	#ifdef DEBUG4
	printf("SCHED_SW = %d;  CPU_SW = %d \n",SCHED_SW,CPU_SW);
	#endif
			   }

			break;
		  default:
			printf("pcb->status = 'T' should be impossible!");
			exit(0);
	      } /* end switch */
   #ifdef DEBUG4
		printf("Exit Eio_Service\n\n");
	#endif

   } /* end Eio_Service */


   void
   Purge_rb( struct pcb_type *pcb )
   /* ------------------------------------------------------------------------- */
	/*       This-function-purges-all-RBs-in-the-'complete'-status               */
	/* ------------------------------------------------------------------------- */
	{
	struct rb_list *ptr2listnode, *tracer, *prev;
	int foundflag = FALSE,
		i = 0;

	#ifdef DEBUG4
		printf("entered Purge_rb\n");
			Dev_rblist();
	#endif


	tracer = pcb->firstrb;
	prev = NULL;

	while (tracer != NULL)
	{
	  if (tracer->rb->status == 'D')
	  {
		  if(tracer == pcb->firstrb) /* if 1st node */
		  {
		if (pcb->firstrb == pcb->lastrb) /* only one node */
		{
		i++;
		  pcb->firstrb = NULL;
		  pcb->lastrb = NULL;
		  free(tracer);
	#ifdef DEBUG4
			Dev_rblist();
		printf("only one node - Purged %d rb\n", i);
	#endif
		} /* end only one node */
		else
		{
		i++;
		  pcb->firstrb = pcb->firstrb->next;
		  free(tracer);
	#ifdef DEBUG4
			Dev_rblist();
		printf("more than one-Purged %d rb\n", i);
	#endif
		}
		tracer = pcb->firstrb;
		  } /* end if 1st node */
		  else /* not 1st node */
		  {
		if (tracer == pcb->lastrb) /* if last node */
		{
		i++;
		  pcb->lastrb = prev;
		  pcb->lastrb->next = NULL;
		  free(tracer);
	#ifdef DEBUG4
			Dev_rblist();
		printf("node was tail - Purged %d rb\n", i);
	#endif
		}
		else
		{
			i++;
			prev->next = tracer->next;
			free(tracer);
	#ifdef DEBUG4
				Dev_rblist();
		printf("middle node - Purged %d rb\n", i);
	#endif
		}/* end middle child */
		  } /* end else not 1st node */
		/*  free(tracer->rb); */
	  } /* end if equal to 'D' */
	  else
	  {
		 prev = tracer;
		 tracer = tracer->next;
	  } /* end else not equal to 'D' */

	} /* end while tracer != NULL */




	#ifdef DEBUG4
			Dev_rblist();
		printf("Exit Purge_rb\n\n");
	#endif

   } /* end Purge_rb */


   void
   Dispatcher(void)
   /* ------------------------------------------------------------------------ */
   /*  This function prepares the scheduled program for execution and then     */
	/*  transfers control to it.  This is done by:                              */
	/*  (1)  Calling LoadMap() to initialize and load the lower half of MEMMAP  */
   /*       from the user's segment table.                                     */
	/*  (2)  calling XPGM() with the program's state( &CPU.actvpcb->cpu_save ). */
   /* ------------------------------------------------------------------------ */
   {
   
	#ifdef DEBUG4
		printf("entered Dispatcher\n");
		Dev_rblist();
	#endif
    LoadMap(CPU.actvpcb->segtable, CPU.actvpcb->segtab_len);
	 XPGM(&CPU.actvpcb->cpu_save);
	#ifdef DEBUG4
		Dev_rblist();
		printf("Exit Dispatcher\n\n");
	#endif

   } /* end Dispatcher */



   void
   LoadMap(struct segment_type *segtab, int numseg )
   /* ------------------------------------------------------------------------ */
   /*  This function is called by the Dispatcher() to initialize the MEMMAP    */
   /*  hardware with the dispatched program's segment table.  This function    */
   /*  simulates the action of priviledged instructions that normally perform  */
   /*  this operation. LoadMap does the following:                             */
   /*                                                                          */
	/*  (1) Initialize MEMMAP[s].Acc to 0x00, 0 <= s < MAXSEGMENTS.             */
   /*  (2) Copy user's segment table into MEMMAP[s], 0 <= s < numseg.          */
   /* ------------------------------------------------------------------------ */
	{
		int i;

	#ifdef DEBUG4
		printf("entered LoadMap\n");
	#endif
		for (i = 0; i < MAXSEGMENTS; i++)
		{
			MEMMAP[i].accbits = 0x00;
		}
		for (i = 0; i < numseg; i++)
		{
			MEMMAP[i].accbits = segtab[i].accbits;
			MEMMAP[i].seglen = segtab[i].seglen;
			MEMMAP[i].membase = segtab[i].membase;
		}
	#ifdef DEBUG4
		Dev_rblist();
		printf("Exit LoadMap\n\n");
	#endif
   
   } /* end LoadMap */

/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
   End   OBJECTIVE 4
****************************************************************************/


