/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
   Simulator Project    Original Design:  Dr. David Workman
	Revised  Tim Hughey  Mark Stephens

	OBJECTIVE 6
	obj6.c - Version 1.1    - created April 25, 1999
				- last updated April 27, 1999

****************************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"

/*
#define DEBUG6
*/

/*************************** Objective 6 functions **************************/
void
Freemem_list(void)
/* ---------------------------------------------------------------------------*/
/*   This is my function to print the freemem list to tthe screen for debug   */
/* ---------------------------------------------------------------------------*/
{
	struct seg_list	*tracer, *ptracer;
	int 					x = 0;

	tracer = FreeMem;
	ptracer = NULL;

	while(tracer != NULL)
	{
		x++;
		printf("FreeMem:  %d - segsize: %u;  memindex: %u;   \n",
				x, tracer->segsize, tracer->segptr);
		tracer = tracer->next;
	} /* end while */
} /* end Freemem_list() */


void
Timer_Service(void)
/* ------------------------------------------------------------------------- */
/*  This function services Timer interrupts.  When one occurs, the           */
/*  active process is removed from the CPU, provided ROUND ROBIN             */
/*  is the active scheduling policy; otherwise, the active process           */
/*  is allowed to continue.                                                  */
/*                                                                           */
/*     NOTE: Timer interrupts should only occur with a preemptive            */
/*           scheduler like RNDRBN.                                          */
/* ------------------------------------------------------------------------- */
{

/* not used in this project because scheduling algorithm is FCFS */

}


void
Compact_mem(void)
/* ---------------------------------------------------------------------------*/
/*   This is the memory compaction function.  It should be called only if     */
/*   there is enough free space to accommodate the next program to be loaded  */
/* ---------------------------------------------------------------------------*/
{
	unsigned long	putindex,  /* MEM index that moved instruction will be put */
						moveindex, /* MEM index of instruction that will move */
						memcount;  /* amount of instructions that will be moved */

	struct seg_list  	*tracer, *next_tracer;  /* ponters to trace FreeMem list */

	int				nodecount = 0, i, j;		/* for incrementation */
	#ifdef DEBUG6
	printf("Entered compact_mem\n");
	Freemem_list();
	#endif

	tracer = FreeMem;
	next_tracer = NULL;
	while(tracer != NULL)   /* count FreeMem nodes */
	{
		nodecount++;
		tracer = tracer->next;
	} /* end while tracer != NULL */

	if (nodecount > 1) /* more than one FreeMem node */
	{
		tracer = FreeMem;
		next_tracer = tracer->next;
		/****** set values to move mem instructions ******/
		moveindex = tracer->segptr + tracer->segsize;
		memcount =  next_tracer->segptr - moveindex;
		putindex = tracer->segptr;
		/****** move mem instructions ******/
		for(i = 0; i < memcount; i++)
		{
			MEM[putindex + i] = MEM[moveindex + i];
		} /* end for */
		/****** shift FreeMem segptr for first node ******/
		FreeMem->segptr = putindex + memcount;

		#ifdef DEBUG6
		Freemem_list();
		printf("MEMSIZE = %d;  Calling Merge seg...\n", MEMSIZE);
		#endif

		Merge_seg();

		#ifdef DEBUG6
		Freemem_list();
		#endif
	} /* end if more than one FreeMem node */
	else
	{
		tracer = FreeMem;
		/****** set values to move mem instructions ******/
		moveindex = tracer->segptr + tracer->segsize;
		memcount =  MEMSIZE - moveindex;
		putindex = tracer->segptr;
		/****** move mem instructions ******/
		for(i = 0; i < memcount; i++)
		{
			MEM[putindex + i] = MEM[moveindex + i];
		} /* end for */
		/****** shift FreeMem segptr for first node ******/
		FreeMem->segptr = putindex + memcount;
	} /* end else only one FreeMem node */

	#ifdef DEBUG6
	printf("Exit compact_mem\n");
	#endif
} /* end Compact_mem */
