/* HEXHPART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *-------------------------- HEX STUFF FUNCTIONS  ----------------------------*

\******************************************************************************/	


/*--------------------T W O _ H E X _ T O _ B Y T E---------------------------\
 takes two chars, which are really hex digits and stuffs 'em together
 into one single byte
\-----------------------------------------------------------------------------*/
void two_hex_to_byte(char lmhb, char rmhb, char *byte_ptr)
{
	int k;
     /* Looks for the hexdigit that matches the Left Most Half Byte*/
	for (k=0; HEXDIG[k]!=lmhb; ++k)
			;
	 /*Putting the lmhb in the byte */
      	*byte_ptr= RMHBHEX[k];
	*byte_ptr = *byte_ptr<<4;
   
	 /*Find out which hex rmhb is */
      	for (k=0; HEXDIG[k]!= rmhb; ++k)
			;
   
	/* put the rmhb in the byte */
      	*byte_ptr = *byte_ptr | RMHBHEX[k];
} /* end two_hex_to_byte*/


/*--------------------B Y T E _ T 0 _ H E X------------------------------------\
 takes a byte as an argument and prints out the hexadecimal form of that
 byte
\-----------------------------------------------------------------------------*/
void byte_to_hex(FILE **fp, char onebyte)
{
	byte b;

	b= onebyte;
	b >>=4;
	b= b & '\017'; /*Like ANDing b with 0000 1111; \017 = 15 in base 10 */
                   /* Doing this removes the need for an unsigned char !!! */
	fprintf(*fp,"%c",HEXDIG[b]);
        b= onebyte & '\017';
	fprintf(*fp,"%c ", HEXDIG[b]);
} /* end byte_to_hex */

/*----------------D E C I M A L _ T 0 _ H E X----------------------------------\
 Takes a decimal number and coverts it into it's hexadecimal form--entering
 it into word_array
\-----------------------------------------------------------------------------*/
void decimal_to_hex (int dec_num, char word_array[])
{
	int dividend,
       hexdigit, i;

	dividend= dec_num;

	for (i=0; i<=5; i++)     /*padding word_array with 0's*/
        word_array[i]= HEXDIG[0];
	word_array[6]='\0';
  
	i=5;
	while ( (dividend / 16)!=0 )  /*or is it DIV??*/
	{
        	hexdigit= dividend % 16;
		word_array[i]= HEXDIG[hexdigit];
	        dividend= dividend / 16;
		i--;
      	}
	if ( (dividend / 16)==0 )
      	{
		hexdigit= dividend % 16;
		word_array[i]= HEXDIG[hexdigit];
	}

}/* end decimal_to_hex */



