/* TOK1PART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *-----------------------     GET TOKENS FUNCTION  --------------------------*

\******************************************************************************/	


/*------------------------  G E T _ T O K E N S 1  ----------------------------\

 Purpose: This function returns to the caller all of the different parts
	  of an input line in a tokenized form. It also takes into account
	  whether or not there are labels and operands.

 Pre-Condition : <None>

 Post-Condition: input line is parsed into tokens

 Return: void

\-----------------------------------------------------------------------------*/
void get_tokens1(char line[INP_LENGTH +1],char lbl[NAME_LENGTH +1],
		 char  opr[OP_LENGTH + 1],  char ond[OPND_LENGTH + 1],
		 int *op_ind, int *len)
{

	char  *temp,
	      delim[]=" \t"; 
		/*Delimiter used in strtok for ignoring spaces and tabs*/


	int   lbl_FLAG=FALSE,
		ond_FLAG=FALSE,
		temp_int;

	if (line[0]=='\n' || line[6]=='.')
	{
		lbl[0]='\0';
		opr[0]='\0';
		ond[0]='\0';
		*op_ind=0;
		*len=0;
	}
	else if (line[0]!='\n' || line[6]!='.')
	{
		if (line[8] != BLANK || line[9] != BLANK)   
					/*Checks to see if you have a label*/
			lbl_FLAG = TRUE;
		if (line[24]!=BLANK || line[25]!=BLANK) 
					/*Checks to see if you have an operand*/
			ond_FLAG= TRUE;
		temp = strtok(line, delim); 
			/*This gets the first token which is Pass1's locctr*/
		sscanf (temp, "%x", &locctr);
		if (lbl_FLAG==TRUE && ond_FLAG==TRUE)
	/* If there IS a label AND there IS an operand---do the following */
		{
			temp     =strtok(NULL, delim);
			strcpy(lbl, temp);
			temp     =strtok(NULL, delim);
			strcpy(opr,temp);
			temp     = strtok(NULL, delim);
			strcpy(ond,temp);
			temp       = strtok(NULL, delim);
			temp_int = atoi(temp);
			*op_ind  = temp_int;
			temp       = strtok(NULL, delim);
			temp_int = atoi(temp);
			*len     = temp_int;
		}

		if (lbl_FLAG==FALSE && ond_FLAG==TRUE)
         /* If there IS NOT a label but there IS an operand, do the following */
	        {
			lbl[0]   ='\0';
			temp     =strtok(NULL, delim);
			strcpy(opr,temp);
			temp     =strtok(NULL, delim);
			strcpy(ond,temp);
			temp       =strtok(NULL, delim);
			temp_int = atoi(temp);
			*op_ind  = temp_int;
			temp       =strtok(NULL, delim);
			temp_int =atoi(temp);
		 	*len     =temp_int;
		}
		if (lbl_FLAG==TRUE && ond_FLAG==FALSE)
	 /*If there is NOT a label and there IS an operand do the following...*/
		{
			temp     =strtok(NULL, delim);
		 	strcpy(lbl, temp);
			temp     =strtok(NULL, delim);
			strcpy(opr,temp);
			ond[0]   ='\0';
			temp        =strtok(NULL, delim);
			temp_int  =atoi(temp);
			*op_ind   =temp_int;
			temp        =strtok(NULL, delim);
			temp_int  =atoi(temp);
			*len      =temp_int;
		}
		if (ond_FLAG==FALSE && lbl_FLAG==FALSE)
	/*If there is NOT a label and there IS NOT an operand do the following*/
		{
			lbl[0]   ='\0';
			temp     =strtok(NULL, delim);
			strcpy(opr,temp);
			ond[0]   ='\0';
			temp        =strtok(NULL, delim);
			temp_int  =atoi(temp);
			*op_ind   =temp_int;
			temp        =strtok(NULL, delim);
			temp_int  =atoi(temp);
			*len      =temp_int;
		}
	}
} /* end get_tokens1 */
