/* FMT4PART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *---------------------------  FORMAT 4 FUNCTION  ---------------------------*

\******************************************************************************/

/*-------------------------------- F M T 4  -----------------------------------\

 Purpose: This routine is used by pass2 to process format 4 instructions

 Pre-Condition : <None>

 Post-Condition:

 Return: void

\-----------------------------------------------------------------------------*/
void fmt4(FILE **fp, struct ot_entry *ot, int opidx, struct st_entry *st,
	char lbl[NAME_LENGTH + 1], char ond[OPND_LENGTH + 1])
{
	int  i,k,l,  /* counting variables */
	     PC,            /* used to store the program-counter */
	     TA,            /* target address */
	     temp_int,
	     X_FLAG=FALSE   /* flag for indexed addressing*/ ;


	char *ond_str, /*operand will be strtok'ed and it's remainder willl be stored here*/
             imm_val[7],
	     half_byteL,    /*half byte variables to store hex digits*/
	     half_byteR,
	     single_byte;   /*what you get when you fuse two hex digits together*/

	fprintf(*fp, "%3d    ", lineno);
	PC= locctr+4;

	for (i=0; i<4; i++)
		objcode[i]=0;

	objcode[0]= ot[opidx].ot_opcode;  /*shoving the opcode of the operator into
												 objcode[0]*/
	temp_int= strlen(ond);   /* deciding on whether or not ond is indexed*/
	if (ond[temp_int-1]=='X' && ond[temp_int-2]==',')
	{
		X_FLAG=TRUE;
		flip_the_bit(8, &objcode[1]);
	}


/*________________IMMEDIATE ADDRESSING__________________________________*/
	if (ond[0]=='#')
	{
		flip_the_bit (1, &objcode[0]); 
			/*Note to BT: I LOVE THE NAME FOR THIS FUNC.*/
		ond_str= strtok(ond,"#");
		/*If it is immediate addressing with a label and NOT a number, 
		  we look up the label's value and put it into tmep_int*/
		if (isalpha(ond_str[0]))
		{
			i=0;
			while (strcmp(st[i].st_name, ond_str)!=0)
				 i++;
			temp_int= st[i].st_value;
		}
		else
			temp_int= atoi(ond_str);
		decimal_to_hex(temp_int, imm_val); 
		/*decimal_to_hex stores the number in 
		  the operand as hex chars and stores them here*/
		k=0;
		l=1;
		for (i=1; i<=3; i++)
		/*This part coverts each pair of hex digits and combines		each pair into one single byte*/
		{
			half_byteL= imm_val[k];
			k++;
			half_byteR= imm_val[k];
			k++;
			two_hex_to_byte(half_byteL, half_byteR, &single_byte);
			objcode[l]= single_byte;
			l++;
		}
		flip_the_bit(5, &objcode[1]);
	}/*end if #number */

/*________________DIRECT_ADDRESSING____________________________________*/
		 /*handles conditions where there is a label in the operand field*/
	if (isalpha(ond[0]) && !X_FLAG)
	{
		flip_the_bit (1, &objcode[0]);
		flip_the_bit (2, &objcode[0]);
		i=0;
		while (strcmp(st[i].st_name, ond)!=0)
			 i++;
		temp_int= st[i].st_value;
		decimal_to_hex(temp_int, imm_val);
		k=0;
		l=1;
	/*converts each pair of chars in imm_val and stores them into objcode*/
		for (i=1; i<=3; i++)
		{
			half_byteL= imm_val[k];
			k++;
			half_byteR= imm_val[k];
			k++;
			two_hex_to_byte(half_byteL, half_byteR, &single_byte);
			objcode[l]= single_byte;
			l++;
		}
		flip_the_bit(5, &objcode[1]);
	} /*end DIRECT*/

/*________________INDEXED_ADDRESSING____________________________________*/
	if (isalpha(ond[0]) && X_FLAG)
	{
		ond_str= strtok (ond, " ,");
		flip_the_bit (1, &objcode[0]);
		flip_the_bit (2, &objcode[0]);
		i=0;
		while (strcmp(st[i].st_name, ond_str)!=0)
			i++;
		TA= st[i].st_value;
		decimal_to_hex(TA, imm_val);
		k=0;
		l=1;
	/*converts each pair of chars in imm_val and stores them into objcode*/
		for (i=1; i<=3; i++)
		{
			half_byteL= imm_val[k];
			k++;
			half_byteR= imm_val[k];
			k++;
			two_hex_to_byte(half_byteL, half_byteR, &single_byte);
			objcode[l]= single_byte;
			l++;
		}
		/*turning on the 'e' and 'x' bit */
		flip_the_bit (5, &objcode[1]);
		flip_the_bit (8, &objcode[1]);
	} /*end INDEXED*/
/*________________PRINTING STUFF OUT IN HEX________________________________*/
	for (i=0; i<=3; i++)
	byte_to_hex(&temp_fptr, objcode[i]);
	for (i=1; i<=4; i++) /*lining up the output */
	fprintf(*fp," ");

	for (i=0; i<=3; i++)
	{
		bit_print(&temp_fptr, objcode[i]);
		fprintf(*fp," ");
	}
	fprintf(*fp,"\n");
}/* end of fmt4 */

/*---------------------- C O P Y _ T E M P _ F I L E   ------------------------\

 Purpose: This routine is used by the main routine after all the input  
	  has been processed.  This routine copies the temporary output 
	  file (temp_fptr) into the main output file (out_fptr).         

 Pre-Condition : <None>

 Post-Condition:

 Return: void

\-----------------------------------------------------------------------------*/
void copy_temp_file(FILE **temp, FILE **out)
{
	char inp_line[INP_LENGTH + 1]; /* input assembly line */
	     inp_line[0]='\0';
	     fclose (*temp);

	if((*temp=fopen("temp.dat", "r")) == NULL) /* opens temp file */
	{
		fprintf(stderr, "Error opening temp file.");
		exit(1);
	};
	fprintf(*out, "\n\n");
	while (fgets(&inp_line[0], INP_LENGTH, temp_fptr) != NULL)
		fprintf(*out, "%s", inp_line);
}/* end of copy_temp_file */
