
/****************************************************************************/
/*              Bettina McCormick               COP 4020 SUM '98
/*
/*              LAB 4 - Due July 29, 1998       Prolog
/****************************************************************************/

/****************************************************************************/
/*-----------------------------   setMinus   -------------------------------*/
/* This predicate accepts two sets S1 and S2.  The predicate generates a    */
/* list containing S1-S2 (the set S1-S2 is all the elements in S1 which     */
/* are not in S2).                                                          */
/*--------------------------------------------------------------------------*/

setMinus(S1,[],S1).
setMinus([],S2,[]).
setMinus(L1,[A|S2],M) :- eraseAll(A,L1,Q), setMinus(Q,S2,M).

/*- eraseAll -*/
/* This predicate accepts an element, E and a set S.  The predicate         */
/* erases or deletes all the occurances of E in S.                          */ 
/*--------------------------------------------------------------------------*/

eraseAll(_,[],[]).
eraseAll(E,[E|L],M) :- eraseAll(E,L,M).
eraseAll(E,[B|L],[B|M]) :- eraseAll(E,L,M).
/****************************************************************************/


/****************************************************************************/
/*----------------------------   palindrome   ------------------------------*/
/* This predicate accepts a list L.  The predicate succeeds if L is         */
/* a palindrome.                                                            */
/*--------------------------------------------------------------------------*/

palindrome([]).
palindrome([A]).
palindrome(L) :- rev(L,L).

/*- rev -*/
/* This predicate accepts a list L1 and reverses the list.                  */ 
/*--------------------------------------------------------------------------*/
rev([],[]).
rev([H|T],L1) :- rev(T,Z), append(Z,[H],L1).

/*- append -*/
/* This predicate accepts 2 lists L1 & L2.  The predicate                   */
/* appends L2 to L1.                                                        */ 
/*--------------------------------------------------------------------------*/

append([],L2,L2).
append([A|L1],L2,[A|L3]) :- append(L1,L2,L3).
/****************************************************************************/

/****************************************************************************/
/*-------------------------------   shift   --------------------------------*/
/* This predicate accepts a list L and a positive integer Count.            */
/* The predicate generates a list equivalent to L circular shifted Count    */
/* positions (the shift is to the right).                                   */
/*--------------------------------------------------------------------------*/

shift(L,0,L).
shift([A|T],Count,N) :- append(T,[A],M),C1 is Count-1, shift(M,C1,N).

/*- append -*/
/* This predicate accepts 2 lists L1 & L2.  The predicate                   */
/* appends L2 to L1.                                                        */ 
/*--------------------------------------------------------------------------*/

append([],L2,L2).
append([A|L1],L2,[A|L3]) :- append(L1,L2,L3).
/****************************************************************************/
