/****************************************************************************/
/*		Bettina McCormick		COP 4020 SUM '98
/*
/*              LAB 3 - Due July 20, 1998    	Prolog
/****************************************************************************/

/*---------------------------   evenLength   -------------------------------*/
/* This predicate accepts a list L.  The predicate succeeds if L has an     */
/* even number of elements.						    */
/*--------------------------------------------------------------------------*/
evenLength([]).
evenLength([A,B]).
evenLength([A,B|Y]) :- evenLength(Y).


/*----------------------------   multiples   -------------------------------*/
/* This predicate accepts a list L and a number NUM.  The predicate 	    */
/* generates a list containing elements in L that are multiples of NUM,     */
/* i.e., elements that are divisible by NUM.				    */
/*--------------------------------------------------------------------------*/

multiples([],_,[]).
multiples([A|Tail],NUM,[A|M]) :- is_multiple(A,NUM), multiples([Tail],NUM,M). 
multiples([B|Tail],NUM,[C|M]) :- multiples([Tail],NUM,M).

/*- is_multiple -*/
/* This predicate accepts a number A and a number NUM.  The predicate 	    */
/* succeeds if A is a multiple of NUM.					    */
/*--------------------------------------------------------------------------*/

is_multiple(A,A).
is_multiple(A,NUM) :- 0 is A mod NUM.


/*-----------------------------   addPair   --------------------------------*/
/* This predicate accepts two lists L1 and L2, each containing integers.    */
/* The predicate generates a list containing the sum of elements (pair-wise)*/ 
/* in the two lists.  If one list has fewer elements than the other list,   */
/* zero should be used as the value for the missing elements.		    */
/*--------------------------------------------------------------------------*/

addPair([],L2,L2).
addPair(L1,[],L1).
addPair([A|T1],[B|T2],[C|T3]) :- C is A + B, addPair(T1,T2,T3).




